//=====================================================================================
#include "gheader.h"
//=====================================================================================
#ifdef ENABLE_APIAKEY_MODE 
//=====================================================================================
static idata BYTE bAnalogKeyReleaseTime;
static bdata bit  bAnalogKeyStatus;

static BYTE idata Key1PressCount;
static BYTE idata Key2PressCount;
static BYTE idata Key3PressCount;
static BYTE idata Key4PressCount;
void API_AnalogKeyInitial(void)
{
	DRV_AnalogKeyInitial();
	bAnalogKeyReleaseTime = 0;
  	bAnalogKeyStatus = 0;

}
//=======================================================================================
//
//=======================================================================================
void DRV_CheckAnalogKeyRoutine(void)
{

WORD bChannel0Data=0,bChannel1Data=0;
	
	

	if(PMCTL_DATA[PMCTL_DATA_ADC_EN_NO] & 0x01) // enable /disable read ADC function
	{
		bChannel0Data = API_AverageADCData(0x01);			
		PMCTL_DATA[PMCTL_DATA_ADC_DATA0H_NO] = bChannel0Data / 256; //read adc high byte data
		PMCTL_DATA[PMCTL_DATA_ADC_DATA0L_NO] = bChannel0Data % 256;//read adc low byte data
	}

	if(PMCTL_DATA[PMCTL_DATA_ADC_EN_NO] & 0x02)// enable /disable read ADC function
	{
		bChannel1Data = API_AverageADCData(0x02);
		PMCTL_DATA[PMCTL_DATA_ADC_DATA1H_NO] = bChannel1Data / 256;//read adc high byte data
		PMCTL_DATA[PMCTL_DATA_ADC_DATA1L_NO] = bChannel1Data % 256;//read adc low byte data
	}

	#ifdef ENABLE_UARTDEBUG_MODE
				//DRV_Printf("bChannel0Data = %d \r\n",bChannel0Data);
				//DRV_Printf("bChannel1Data = %d \r\n",bChannel1Data);
			#endif


	if(bChannel0Data >= NO_PRESS_LEVEL) //key release
	{
		Key1PressCount = 0;
		Key2PressCount = 0;
		Key3PressCount = 0;
		Key4PressCount = 0;

		bAnalogKeyStatus = KEY_RELEASE;

	}	
	else //key press
	{   
	
		
		if(bAnalogKeyStatus==KEY_RELEASE && bAnalogKeyReleaseTime==0)	
		{
			// de-bounce counter
			if((bChannel0Data >= (KEY1_LEVEL-AKEY_TOLERANCE)) && (bChannel0Data <= (KEY1_LEVEL+AKEY_TOLERANCE)))
		  	{
		  		Key1PressCount++;
		  	}
			if((bChannel0Data >= (KEY2_LEVEL-AKEY_TOLERANCE)) && (bChannel0Data <= (KEY2_LEVEL+AKEY_TOLERANCE)))
		  	{
		  		Key2PressCount++;
		  	}
			if((bChannel0Data >= (KEY3_LEVEL-AKEY_TOLERANCE)) && (bChannel0Data <= (KEY3_LEVEL+AKEY_TOLERANCE)))
		  	{
		  		Key3PressCount++;
		  	}
			if(bChannel0Data <= (KEY4_LEVEL+AKEY_TOLERANCE))
		  	{
		  		Key4PressCount++;
		  	}
		}	
	}

    if(Key1PressCount>=2) //key 1 press
	{
		Key1PressCount = 0;
		bAnalogKeyStatus = AKEY_PUSHED;
		bAnalogKeyReleaseTime = 30; 		//delay 300ms


	
	
		#ifdef ENABLE_UARTDEBUG_MODE
		DRV_Printf("Demo board SWB1 is pressed AD0 = %d \r\n ",bChannel0Data); 		
		#endif

		
	}
	if(Key2PressCount>=3) //key 2 press
	{ 
		Key2PressCount = 0;
		bAnalogKeyStatus = AKEY_PUSHED;
		bAnalogKeyReleaseTime = 30; 		//delay 300ms
	
		#ifdef ENABLE_UARTDEBUG_MODE
		DRV_Printf("Demo board SWB2 is pressed AD0 = %d \r\n ",bChannel0Data); 
		#endif
	}
	if(Key3PressCount>=3) //key 3 press
	{
		Key3PressCount = 0;
		bAnalogKeyStatus = AKEY_PUSHED;
		bAnalogKeyReleaseTime = 30; 		//delay 300ms
	
		#ifdef ENABLE_UARTDEBUG_MODE
		DRV_Printf("Demo board SWB3 is pressed AD0 = %d \r\n ",bChannel0Data); 
		#endif
	}
	if(Key4PressCount>=3) //key 4 press
	{
		Key4PressCount = 0;
		bAnalogKeyStatus = AKEY_PUSHED;
		bAnalogKeyReleaseTime = 30; 		//delay 300ms
		
		#ifdef ENABLE_UARTDEBUG_MODE
		DRV_Printf("Demo board SWB4 is pressed AD0 = %d \r\n ",bChannel0Data); 
		#endif
		
		#if 0
		if(PowerStatus==POWER_OFF)
		{
			System_Power_ON(HOST_WAKEUP_VIA_AKEY);
		}
		else
		{
			System_Power_OFF(HOST_PWRDOWN_VIA_AKEY);
		}
		#endif
	}

	
}
//=======================================================================================
//
//=======================================================================================
void DRV_AnalogKeyRelease10mS(void)
{
	if(bAnalogKeyReleaseTime)
    {
   		bAnalogKeyReleaseTime--;
   	}		
}
	
		




//=======================================================================================
//
//=======================================================================================
#endif
