//=====================================================================================
#include "gheader.h"
//=====================================================================================
#ifdef ENABLE_APIRTC_MODE

//=====================================================================================
//
//=====================================================================================
void API_UpdateRtc(void)
{
  if(gbRtcUpdateFlag != 0x00)
  {   
		API_BackupRtcTime();
		
		rRTC_CTL |= 0x60;  		//Enable RTC WR/RD		
		rRTC_OSC |= 0x40; 		//Stop RTC counting
//-----------------------------------------------------------------------------------
    //Check year
    if(RTC_YEAR_FLAG)
			{
      rRTC_YEAR = ((((BYTE)(gbRtcYear/10)) << 4) + (gbRtcYear%10));    //BCD format    
			}
		else
			{
			rRTC_YEAR = gbBackupRtcYear;    
			}
//-----------------------------------------------------------------------------------
    //Check week
    if(RTC_WEEK_FLAG)
			{
      rRTC_WEEK = gbRtcWeek;
			}
		else
			{
			rRTC_WEEK = gbBackupRtcWeek;
			}
//-----------------------------------------------------------------------------------
    //Check month
    if(RTC_MONTH_FLAG)
			{
      rRTC_MONTH = gbRtcMonth;
			}
		else
			{
			rRTC_MONTH = gbBackupRtcMonth;
			}
//-----------------------------------------------------------------------------------
    //Check day
    if(RTC_DAY_FLAG)
			{
      rRTC_DAY = ((((BYTE)(gbRtcDay/10)) << 4) + (gbRtcDay%10));    //BCD format
			}
		else
			{
			rRTC_DAY = gbBackupRtcDay;    
			}
//-----------------------------------------------------------------------------------
    //Check hour
    if(RTC_HOUR_FLAG)
			{
      rRTC_HOUR = ((((BYTE)(gbRtcHour/10)) << 4) + (gbRtcHour%10));    //BCD format
			}
		else
			{
			rRTC_HOUR = gbBackupRtcHour;    
			}
//-----------------------------------------------------------------------------------
    //Check minute
    if(RTC_MIN_FLAG)
			{
      rRTC_MIN = ((((BYTE)(gbRtcMin/10)) << 4) + (gbRtcMin%10));    		//BCD format
			}
		else
			{
			rRTC_MIN = gbBackupRtcMin;    		
			}
//-----------------------------------------------------------------------------------	
    //Check second
    if(RTC_SEC_FLAG)
			{
      rRTC_SEC = ((((BYTE)(gbRtcSec/10)) << 4) + (gbRtcSec%10));    		//BCD format
			}
		else
			{
			rRTC_SEC = gbBackupRtcSec;    		
			}
//-----------------------------------------------------------------------------------		
		gbRtcUpdateFlag = 0;
		//Enable RTC
		rRTC_OSC &= 0xBF;  		//Enable RTC
		rRTC_CTL &= 0x9F;		//Disable RTC WR/RD    
  }
	//update time
	//Enable RTC
	rRTC_CTL |= 0x80;
	API_ReadRtcTime();
}
//=====================================================================================
//
//=====================================================================================
void API_ReadRtcTime(void)
{
rRTC_CTL |= 0x60;  		//Enable RTC WR/RD
gbRtcSec = (rRTC_SEC >> 4)*10 + (rRTC_SEC & 0x0F);     //BCD format
gbRtcMin = (rRTC_MIN >> 4)*10 + (rRTC_MIN & 0x0F);     //BCD format
gbRtcHour = (rRTC_HOUR >> 4)*10 + (rRTC_HOUR & 0x0F);  //BCD format
gbRtcDay = (rRTC_DAY >> 4)*10 + (rRTC_DAY & 0x0F);     //BCD format
gbRtcWeek = rRTC_WEEK;
gbRtcMonth = rRTC_MONTH;
gbRtcYear = (rRTC_YEAR >> 4)*10 + (rRTC_YEAR & 0x0F);  //BCD format
rRTC_CTL &= 0x9F;		//Disable RTC WR/RD 
}
//=====================================================================================
//
//=====================================================================================
void API_BackupRtcTime(void)
{
//backup RTC time
rRTC_CTL |= 0x60;  		//Enable RTC WR/RD
gbBackupRtcSec = rRTC_SEC;     
gbBackupRtcMin = rRTC_MIN;     
gbBackupRtcHour = rRTC_HOUR;  
gbBackupRtcDay = rRTC_DAY;     
gbBackupRtcWeek = rRTC_WEEK;
gbBackupRtcMonth = rRTC_MONTH;
gbBackupRtcYear = rRTC_YEAR;  
rRTC_CTL &= 0x9F;		//Disable RTC WR/RD
}


//=====================================================================================
//
//=====================================================================================
void API_WakeUpAlarmRoutine(void)
{ 
  	//Check wake up time
  	if((gbRtcSec == wakeup_sec)&& (gbRtcMin == wakeup_min) && (gbRtcHour == wakeup_hour))
  	{
	 
    	if(wakeup_day == 0)
    	{
      		//everyday
      		System_Power_ON(HOST_WAKEUP_VIA_ALARM);
    	}
    	else if((wakeup_day >= 1) && (wakeup_day <= 31))
    	{
			
      		if((gbRtcDay == wakeup_day) && (gbRtcMonth == wakeup_month) && (gbRtcYear == wakeup_year))
			{				 
        		System_Power_ON(HOST_WAKEUP_VIA_ALARM);
			}
    	}
    	else if((wakeup_day >= 32) && (wakeup_day <= 38))
    	{
      		//sun ~ sat
      		if(gbRtcWeek == (wakeup_day - 32))
        		System_Power_ON(HOST_WAKEUP_VIA_ALARM);
    	}
    	else if(wakeup_day == 39)
    	{
      		//mon ~ fri
      		if((gbRtcWeek >= 1) && (gbRtcWeek <= 5))
        		System_Power_ON(HOST_WAKEUP_VIA_ALARM);
    	}
    	else if(wakeup_day == 40)
    	{
      		//mon ~ sat
      		if((gbRtcWeek >= 1) && (gbRtcWeek <= 6))
        		System_Power_ON(HOST_WAKEUP_VIA_ALARM);
    	}
    	else
    	{
    	}
  	}
}
//=====================================================================================
//
//=====================================================================================
void API_PowerDownAlarmRoutine(void)
{
  	//Check wake up time
  	if((gbRtcSec == pwrdown_sec) && (gbRtcMin == pwrdown_min) && (gbRtcHour == pwrdown_hour))
  	{
    	if(pwrdown_day == 0)
    	{
      		//everyday
      		System_Power_OFF(HOST_PWRDOWN_VIA_ALARM);
    	}
    	else if((pwrdown_day >= 1) && (pwrdown_day <= 31))
    	{
      		if((gbRtcDay == pwrdown_day) && (gbRtcMonth == pwrdown_month) && (gbRtcYear == pwrdown_year))
        		System_Power_OFF(HOST_PWRDOWN_VIA_ALARM);
    	}
    	else if((pwrdown_day >= 32) && (pwrdown_day <= 38))
    	{
      		//sun ~ sat
      		if(gbRtcWeek == (pwrdown_day - 32))
        		System_Power_OFF(HOST_PWRDOWN_VIA_ALARM);
    	}
    	else if(pwrdown_day == 39)
    	{
      		//mon ~ fri
      		if((gbRtcWeek >= 1) && (gbRtcWeek <= 5))
        		System_Power_OFF(HOST_PWRDOWN_VIA_ALARM);
    	}
    	else if(pwrdown_day == 40)
    	{
      		//mon ~ sat
      		if((gbRtcWeek >= 1) && (gbRtcWeek <= 6))
        		System_Power_OFF(HOST_PWRDOWN_VIA_ALARM);
    	}
    	else
    	{
    	}
	}
}	 
#endif
