#ifndef DRV_RTC_H
#define DRV_RTC_H
//=====================================================================================
//#ifdef ENABLE_RTC_MODE
//=====================================================================================
//RTC registers update
#define RTC_SEC_FLAG        DefineBit(gbRtcUpdateFlag, bit0)
#define RTC_MIN_FLAG        DefineBit(gbRtcUpdateFlag, bit1)
#define RTC_HOUR_FLAG       DefineBit(gbRtcUpdateFlag, bit2)
#define RTC_DAY_FLAG        DefineBit(gbRtcUpdateFlag, bit3)
#define RTC_WEEK_FLAG       DefineBit(gbRtcUpdateFlag, bit4)
#define RTC_MONTH_FLAG      DefineBit(gbRtcUpdateFlag, bit5)
#define RTC_YEAR_FLAG       DefineBit(gbRtcUpdateFlag, bit6)

//wake up
#define wakeup_sec          PMCTL_DATA[PMCTL_DATA_ALARM1_SEC_NO]
#define wakeup_min          PMCTL_DATA[PMCTL_DATA_ALARM1_MIN_NO]
#define wakeup_hour         PMCTL_DATA[PMCTL_DATA_ALARM1_HOUR_NO]
#define wakeup_day          PMCTL_DATA[PMCTL_DATA_ALARM1_DAY_NO]
#define wakeup_month        PMCTL_DATA[PMCTL_DATA_ALARM1_MONTH_NO]
#define wakeup_year         PMCTL_DATA[PMCTL_DATA_ALARM1_YEAR_NO]
//power down
#define pwrdown_sec         PMCTL_DATA[PMCTL_DATA_ALARM2_SEC_NO]
#define pwrdown_min         PMCTL_DATA[PMCTL_DATA_ALARM2_MIN_NO]
#define pwrdown_hour        PMCTL_DATA[PMCTL_DATA_ALARM2_HOUR_NO]
#define pwrdown_day         PMCTL_DATA[PMCTL_DATA_ALARM2_DAY_NO]
#define pwrdown_month       PMCTL_DATA[PMCTL_DATA_ALARM2_MONTH_NO]
#define pwrdown_year        PMCTL_DATA[PMCTL_DATA_ALARM2_YEAR_NO]

void API_UpdateRtc(void);
void API_ReadRtcTime(void);
void API_BackupRtcTime(void);
void API_WakeUpAlarmRoutine(void);
void API_PowerDownAlarmRoutine(void);
//=====================================================================================
#endif
//#endif
