//=====================================================================================
#include "gheader.h"
//=====================================================================================

#ifdef ENABLE_UARTDEBUG_MODE	

char u8TxdBuf[UART_TXD_BUFFER_SIZE];
//=====================================================================================
//=====================================================================================
void API_UartDebugInitial(void)
{
	#if(UART_DEBUG_PORT==UART0)
	DRV_Uart0Inital();
	#endif
	#if(UART_DEBUG_PORT==UART1)	
	DRV_Uart1Initial();
	#endif
} 
//==============================================================================
//
//==============================================================================
void DRV_PutChar(char u8Char)
{
	//U16 u16Count=0;
	
	SBUF = u8Char; 				// transfer to uart
	    									// wait transfer completing
	while(TI==0); 					// check flag
	TI = 0; 							// clear flag 
}
//==============================================================================
//
//==============================================================================
void DRV_PutStr(char *pFmt)
{
	char u8Buffer;						// Character buffer

	while (1)
	{
		u8Buffer = *pFmt; 			// Get a character
		if(u8Buffer == _EOS_) 	// Check end of string
			break;

		DRV_PutChar(u8Buffer); 	// Put a character
		pFmt++; 
	}
}
//==============================================================================
//
//==============================================================================
void DRV_IntToStr(U16 u16Val, U8 u8Base, char *pBuf, U8 u8Length)
{
	U8 bShowZero = FALSE;
	U16 u16Divider;
	U8 u8Disp;
	U16 u16Temp;

	u8Length -= 1;
	if(u8Base == 16)	//Hex
	{
		u16Temp = 0x01 << u8Length;
	}
	else				//Dec
	{
		u16Temp = 1;
		while(u8Length--)
		{
			u16Temp *= 10;
		}
	}
	
	if( 0 == u16Val )
	{
		/*
		pBuf[0] = '0';
		pBuf[1] = '\0';
		*/
		if( 16 == u8Base )
		{
			pBuf[0] = '0';
			pBuf[1] = '0';
			pBuf[2] = '0';
			pBuf[3] = '0';
			pBuf[4] = '\0';
		}
		else
		{
			pBuf[0] = '0';
			pBuf[1] = '0';
			pBuf[2] = '0';
			pBuf[3] = '0';
			pBuf[4] = '0';
			pBuf[5] = '\0';
		}
		return;
	}
	
	if( 16 == u8Base )
	{
		u16Divider = 0x1000;
	}	
	else
	{
		u16Divider = 10000;
	}
	
	while( u16Divider )
	{
		u8Disp = u16Val / u16Divider;
		u16Val = u16Val % u16Divider;

		//if( ucDisp )
		if(u16Temp == u16Divider)
		{
			bShowZero = TRUE;
		}
		//if( u8Disp || bShowZero)
		if( u8Disp || bShowZero || (u16Divider>0))
		{
			if( u8Disp < 10 )
				*pBuf = '0' + u8Disp;
			else
				*pBuf = 'A' + u8Disp - 10;
			pBuf ++;
		}

		if( 16 == u8Base )
		{
			u16Divider /= 0x10;
			if(bShowZero)
				u16Temp /= 0x10;
		}
		else
		{
			u16Divider /= 10;
			if(bShowZero)
				u16Temp /= 10;
		}
	}
	*pBuf = '\0';
}
//==============================================================================
//Ex:
//DRV_Printf("Hex = %x\n",0xAA55);
//DRV_Printf("Dec = %d\n",1234);
//==============================================================================
void DRV_Printf(char *pFmt, U16 u16Val)
{
	char u8Buffer;

	while(u8Buffer =(U8)*(pFmt++))
	{
		if(u8Buffer == '%') // check special case
		{
			switch(*(pFmt++)) // check next character
			{
				case 'x': // hexadecimal number
				case 'X':
					DRV_IntToStr(u16Val, 16, u8TxdBuf, 2);
					DRV_PutStr(u8TxdBuf);
				break;
				case 'd': // decimal number
				case 'i':
					DRV_IntToStr(u16Val, 10, u8TxdBuf,5);
					DRV_PutStr(u8TxdBuf);
				break;
				case 'c':
				case 'C':
					DRV_PutChar((char)u16Val);
				break;
			} // switch
		}
		else // general
		{
			DRV_PutChar(u8Buffer); // put a character
		}	
	} // while
}
#ifdef _ENABLE_ADC_TOUCH_ 
void DRV_Uart0SendHex(BYTE xxx)
{
	SBUF = xxx;
	while(TI==0);
	TI=0;
}
#endif
#endif
