//=====================================================================================
//=====================================================================================
#include "gheader.h"

BYTE data CustomerLength;
WORD data CustomerAddress;
BYTE data CustomerStatus;
BYTE data CheckCode[10];

#define UN_CHECK	0x00
#define CHECK_OK	0x01
#define CHECK_FAIL	0x02
#define	ID_ADDR					((uCHAR volatile code*)(0))
#define CUSTOMER_ID_ADDRESS		0x3FF0

//=================================================
//			Function Prototypes
//=================================================
extern void app_main (void);

void Boot_LoadCalibrationData(void);
code BYTE  CustomerTable[];
void Boot_CheckCustomerID(void);
void Boot_Initial_IOPort(void);
void BootDelay(WORD  ms);

void main(void) using 0
{

	//Boot Start
	rSYS_CTL2 = 0x20;				//Reduce flash power by timing share
	rSYS_CTL1 &=~0x80;				//Enable reset have digital filter
	rWATCHDOG |=0xC0;				//Disable watch dog & WDT clock source from MCU clock

	Boot_LoadCalibrationData();
	//Initial GPIO
	Boot_Initial_IOPort();
	CustomerStatus = UN_CHECK;
	Boot_CheckCustomerID();

	#if 0
	if(CustomerStatus!= CHECK_OK)
	{
		rWATCHDOG |=0xC0;				//Disable watch dog & WDT clock source from MCU clock			
		while(1)
		{

		}
	}
	#endif
	BootDelay(3000);
	rGPIOB_TPY = CustomerStatus;
	//BootCode jump to Program code
	app_main();
}
//=====================================================================================
//
//=====================================================================================
void Boot_LoadCalibrationData(void)
{
	//RC Debug
	//rPD_SEL |= 0x04;	//Output RC oscillator to GPIOC5/PWM0
	//rPD_SEL |= 0x01;	//Output crystal oscillator 32.768KHZ to GPIOC5

	if(rLDO_CALIBRATION_DATA & 0x80)
	{
	 	rLDO_DATA = LDO_DEFAULT_18V;
	}
	else
	{
		rLDO_DATA = rLDO_CALIBRATION_DATA;
	}

	// 53  *20% 10.6  Range 74 ~ 42
	//default information block data is 0xFF
	if(rRC_CALIBRATION_DATA & 0x80)
	//if(rRC_CALIBRATION_DATA> 74 || rRC_CALIBRATION_DATA < 42)
	//if(rRC_CALIBRATION_DATA> 0x90 || rRC_CALIBRATION_DATA < 0x40)
	{
	   rOSC_IADJ0 = ROSC_DEFAULT_12MHZ;
	}
	else
	{
		rOSC_IADJ0 = rRC_CALIBRATION_DATA;
	}

}

//=================================================
//			
//=================================================
code BYTE  CustomerTable[] =
{
	'W', //00	
	'e', //01	
	'l', //02	
	't', //03	 	 
	'r', //04	
	'e', //05	
	'n', //06	
	'd', //07 
}; 
//=================================================
//			
//=================================================
void Boot_CheckCustomerID(void)
{
BYTE i;

	CustomerAddress = CUSTOMER_ID_ADDRESS + 1;
	CustomerLength = ID_ADDR[CustomerLength];
	CustomerStatus = CHECK_OK;
	for(i=0;i<=CustomerLength;i++)
	{
		if(ID_ADDR[CustomerAddress+i]!=CustomerTable[i])
		{
			CustomerStatus = CHECK_FAIL;
			//break;
		}

	}

}
//=================================================
//			
//=================================================
void Boot_Initial_IOPort(void)
{
	 // Port A/B/C
	 // OE - 0:input  	1:output
	 // W - 0:Low 1:High
	 // R - 0:Low 1:High
 	
		// Port A bit7: IN 	()
		// Port A bit6: IN 	()
		// Port A bit5: IN 	() 
		// Port A bit4: IN 	()
		// Port A bit3: IN 	()
		// Port A bit2: IN	()
		// Port A bit1: IN	()
		// Port A bit0: IN	()
		rGPIOA_DAT = 0xFF;						
		rGPIOA_OEN = 0x00;
		rGPIOA_PHN = 0x00;


		// Port B bit0: IN	()
		// Port B bit1: IN	()
		// Port B bit2: IN 	() 
		// Port B bit3: IN 	()
		// Port B bit4: IN 	()
		// Port B bit5: IN	()
		// Port B bit6: IN	()
		// Port B bit7: IN	()
		rGPIOB_DAT = 0xFF;
		rGPIOB_OEN = 0x00;		
		rGPIOB_PHN = 0x00;


		// Port C bit0: IN	()
		// Port C bit1: IN 	()
		// Port C bit2: IN	()
		// Port C bit3: IN	()
		// Port C bit4: IN  ()
		// Port C bit5: IN 	()
		// Port C bit6: IN	()
		// Port C bit7: IN	()		
		rGPIOC_DAT = 0xFF; 
		rGPIOC_OEN = 0x00;
		rGPIOC_PHN = 0x00;
	
}
//=====================================================================================
//12MHZ/3=0.25uS
//
//=====================================================================================                                                                                   
void BootDelay(WORD  ms)		                                                  
{                                                                                         
  WORD i, j;                                                                             
                                                                                          
  for(i = 0; i < ms; i++)                                                                 
  {                                                                                       
    
	//for(j = 0; j < 0x8C; j++)	
	for(j = 0; j < 0x96; j++)	                        
    {                                                                                     
      	_nop_();  			//0.25uS                                                                          
      	_nop_();                                                                            
      	_nop_();                                                                            
      	_nop_();                                                                            
      	_nop_();                                                                            
		_nop_();                                                          
      	_nop_();                                                                            
		_nop_();                                                          
      	_nop_();                                                                            
		_nop_();                                                          
      	_nop_();                                                                            
		_nop_();                                                          
     	_nop_(); 									                                                                         
    }                                                                                     
  }                                                                                       
}     




