//=====================================================================================
#include "gheader.h"
//=====================================================================================
#ifdef ENABLE_ADC_MODE 
//=====================================================================================

WORD idata ADC0Level=0,ADC1Level=0;
WORD idata TemperatureLevel=0;

//=====================================================================================
//
//=====================================================================================
//=====================================================================================
void DRV_AnalogKeyInitial(void)
{									    
  	if(PMCTL_DATA[PMCTL_DATA_ADC_EN_NO] & 0x01)
	{
		//Init Adcpad I/O function.
	  	//Set AD0 as input
	  	GPIOB0_PIN_OE = GPIO_INPUT_MODE;    
	  	GPIOB0_PIN_PHN = GPIO_PULL_LOW;     
		GPIO_ADC0_IO_FUN_EN=1;   // Enable ADC special function from register
	}
	if(PMCTL_DATA[PMCTL_DATA_ADC_EN_NO] & 0x02)
	{
		//Set AD1 as input
		GPIOB1_PIN_OE = GPIO_INPUT_MODE;    
	  	GPIOB1_PIN_PHN = GPIO_PULL_LOW;     
		GPIO_ADC1_IO_FUN_EN=1;  // Enable ADC special function from register
	}
/*
		//Set AD2 as input
	GPIOB2_PIN_OE = GPIO_INPUT_MODE;    
  	GPIOB2_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC2_IO_FUN_EN=1;
	//Set AD3 as input
	GPIOB3_PIN_OE = GPIO_INPUT_MODE;    
  	GPIOB3_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC3_IO_FUN_EN=1;	
	//Set AD4 as input
	GPIOB4_PIN_OE = GPIO_INPUT_MODE;    
	GPIOB4_PIN_PHN = GPIO_PULL_LOW;    
	GPIO_ADC4_IO_FUN_EN=1;
	//Set AD5 as input
	GPIOB5_PIN_OE = GPIO_INPUT_MODE;   
	GPIOB5_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC5_IO_FUN_EN=1;
	//Set AD6 as input
	GPIOB6_PIN_OE = GPIO_INPUT_MODE;    
	GPIOB6_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC6_IO_FUN_EN=1;
	//Set AD7 as input
	GPIOB7_PIN_OE = GPIO_INPUT_MODE;    
	GPIOB7_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC7_IO_FUN_EN=1;
*/
	
}
//=======================================================================================
//
//======================================================================================
WORD API_AverageADCData(BYTE ADC_Channel)
{
#define ADC_SUM_TIME		10	
#define	ADC_SORTING_SIZE	0x03	
BYTE R6;	
BYTE R7;
WORD ADC_ConvertData[ADC_SORTING_SIZE];
WORD ADC_TotalData;
	 
	// average ADC data
	for(R6=0;R6<ADC_SORTING_SIZE;R6++)
	{
		ADC_TotalData = 0;
		for(R7=0;R7<ADC_SUM_TIME;R7++)
		{		
			ADC_TotalData = ADC_TotalData + DRV_ReadAnalogChannel(ADC_Channel);	
		}
		ADC_TotalData = ADC_TotalData / 10;
		ADC_ConvertData[R6] = ADC_TotalData;
	}

	//Sorting
	for(R6=0;R6<ADC_SORTING_SIZE;R6++)
	{
		for(R7=0;R7<3;R7++)
		{
			if(ADC_ConvertData[R7] > ADC_ConvertData[R7+1])
			{
				ADC_TotalData = ADC_ConvertData[R7+1];
		  		ADC_ConvertData[R7+1] = ADC_ConvertData[R7];
				ADC_ConvertData[R7]= ADC_TotalData;
			}
		}
	}
	return ADC_ConvertData[1]; 

}



//=======================================================================================
//
//=======================================================================================
WORD DRV_ReadAnalogChannel(BYTE AD_Channel)
{
	WORD AdcWdata;
	BYTE AdcBdata; 
		
	rADC_CHN = AD_Channel;		//Select ADC channe	
	rADC_TMPS &= 0xFE;			//Disable EN_ADC_TMPS
	//select VerF
	//rADC_VREF = VREF_FROM_VDD;
	rADC_CTL &= 0x7F;			//Enable low speed adc(bit7=0) 	
	_nop_();
	rADC_CTL |= 0x40;			//=1:Start ADC converter
	do
	{
	_nop_();
	}
	while(rADC_CTL & 0x40);	//1=>0:convert finish
	AdcBdata = rADC_DATAL;
	AdcBdata = AdcBdata & 0x03;
	AdcWdata = rADC_DATAH;
	AdcWdata = AdcWdata << 2;
	AdcWdata = AdcWdata | AdcBdata;
	return AdcWdata;		
}
//=======================================================================================
//
//=======================================================================================
/*
WORD DRV_ReadTemperatureSensor(void)
{
	WORD AdcWdata;
	BYTE AdcBdata; 
	
	//Select channel
	rADC_CHN = 0x00;		//Disable ADC channel	
	rADC_TMPS |= 0x01;		//Enable EN_ADC_TMPS
	//VREF voltage from internal reference voltage 1.262v
	//(Need clear PD_TMPS, D8H-bit7)
	rPD_TMPS &=0x7F;
	//Start Convert
	rADC_CTL &= 0x7F;			//Enable low speed adc(bit7=0) 	
	_nop_();
	rADC_CTL |= 0x40;			//=1:Start ADC converter
	do
	{
	_nop_();
	}
	while(rADC_CTL & 0x40);	//1=>0:convert finish
	AdcBdata = rADC_DATAL;
	AdcBdata = AdcBdata & 0x03;
	AdcWdata = rADC_DATAH;
	AdcWdata = AdcWdata << 2;
	AdcWdata = AdcWdata | AdcBdata;
	return AdcWdata;		
}
*/
#endif




#ifdef ENABLE_ACOMP_MODE 
//=======================================================================================
//
//=======================================================================================
void DRV_AnalogComparatorInitial(void)
{
	//OP V+ == ACIP == GPIOB0
	//OP V- == ACIN == GPIOB1
	//OP Vout == ACO == GPIOA0/PWM1
	GPIO_ADC0_IO_FUN_EN = 0;
	GPIO_ADC1_IO_FUN_EN = 0;

	rGPIO_CTL3 |= 0x80;		//Enable Analog Comparator IO pad  
	rPD_ACOMP &= 0x7F;		//Enable Analog comparator  

	//Set wakwup
	rWK_CTL0 |= 0x20;
	//Clear All input toggle
	rTOG_CTL4 |= 0x80;

	//Set Compare Interrupt
    //if ACIP > ACIN , th
	//rINT0_CTL1 |= 0x04;
	//EX0 = 1;
}

	





#endif
//=======================================================================================
//
//=======================================================================================

