#ifdef ENABLE_FLASH_MODE 
//=====================================================================================
#define DEBUG_FLASH	ON
/*
Wt61P803 Flash Programming:				   
programming time = (PFM_CTL-1~PFM_CTL)*4us , default (PFM_CTL=9) = 32us ~ 36us
erase time = (PFM_CTL-1~ PFM_CTLL)*2.048ms, default(PFM_CTL=9) =18.432 ~ 20.48ms
                                          => ĳ(PFM_CTL=B) = 20.48 ~  22.528ms
PFM_CTL=0x0C
Programming time = 44us~48us (X, out spec.)
Erase time = 22.528ms ~ 24.576ms (OK)
 */
#define 	ENABLE_PROGRAM				0x10	
#define 	ENABLE_ERASE				0x20


#define 	PROGRAM_TIMING				0x08		
#define 	ERASE_TIMING 				0x08
//=====================================================================================
//=====================================================================================
#define		BASE_ADDR	 			((uCHAR volatile code*)(0))
   

	#define Bank0ADDRESS		0x3000
	#define Bank1ADDRESS		0x3200
	#define Bank2ADDRESS		0x3400
	#define Bank3ADDRESS		0x3600
	#define Bank4ADDRESS		0x3800
	#define Bank5ADDRESS		0x3A00
	#define Bank6ADDRESS		0x3C00
	#define Bank7ADDRESS		0x3E00 	

	
//===================================================================================
	#if 0
	#define 	FLASH_DEFAULT_ADDRESS		Bank0ADDRESS
	#define		FLASH_SIZE							1024
  #define 	FLASH_DEFAULT_SIZE			64
	#define		FLASH_GROUP_SIZE				(FLASH_SIZE/FLASH_DEFAULT_SIZE)		// 1024 / 64 = 16
	#define		FLASH_WRITECYCLE				(FLASH_DEFAULT_SIZE/1)	  				// 64 / 1 = 64
	

	#define		FLASH_OVER_ADDRESS			FLASH_DEFAULT_ADDRESS+(FLASH_GROUP_SIZE*FLASH_DEFAULT_SIZE)
										// 0x3000 + (32 * 64) =  0x3000 + 0x800 = 0x3800
	#endif
	//===================================================================================
 	#define 	FLASH_DEFAULT_ADDRESS		Bank7ADDRESS
	#define		FLASH_SIZE					512
  	#define 	FLASH_DEFAULT_SIZE			8
	#define		FLASH_GROUP_SIZE			(FLASH_SIZE/FLASH_DEFAULT_SIZE)		// 512 / 8 = 64
	#define		FLASH_WRITECYCLE			(FLASH_DEFAULT_SIZE/1)	  				// 8 / 1 = 8
	

	#define		FLASH_OVER_ADDRESS			FLASH_DEFAULT_ADDRESS+(FLASH_GROUP_SIZE*FLASH_DEFAULT_SIZE)
										// 0x3E00 + (64 * 8) =  0x3E00 + 0x200 = 0x4000
//===================================================================================





extern BYTE idata FlashData[FLASH_DEFAULT_SIZE];	
													



//=====================================================================================
extern void DRV_EraseFlash(BYTE bank);
void DRV_SaveFlashData(void);
extern void DRV_ReadFlashData(void);
//=====================================================================================
#endif
