//=====================================================================================
#include "gheader.h"
//=====================================================================================
#ifdef ENABLE_I2C_MODE 
//=====================================================================================
#define  SI2C_RT9BIT 		0x40
#define  SI2C_STOP   		0x20
#define  SI2C_RSTR   		0x10
#define  SI2C_FIRST  		0x04
#define  SI2C_ALRW  		0x02
#define  SI2C_ACK   		0x01 

//------------------------------
//------------------------------
#define	SIIC_CLR_RT			0x80
#define	SIIC_CLR_STOP		0x40
#define	SIIC_CLR_RSTR		0x20
	 
//=====================================================================================
// Init H/W I2C
//=====================================================================================
BYTE idata SubAddr,RevSlave;
void DRV_I2cInitial(void)
{  
	RevSlave = 0;
  	//Init H/W I2C 
	
  	rI2C_CTL = 0xF0;   								//Enable Slave I2C, Clear transmit/receive & STOP interrupt
	rI2C_NUM = 0x00;	
  	rI2C_SADR = HW_SLAVE_ADDR;   					//Set H/W I2C ID=0x26		
	GPIO_I2C_IO_FUN_EN = 1;    						//Set GPIO share function to I2C. 

	#if 1
	rFIFO_CLR |= 0xC0;
	rI2C_CLR |= 0xE0;
	INT0_CTL_SIIC_EN = 1;
	EX0 = 1;
	#endif
  
}
//=====================================================================================
// H/W I2C interrupt routine (For host MCU communication)
// Read command :  C4 C0 92 C3  S + 0x26 + address + Re-S + Receive + P
// Write cmmand :  C4 C0 C0 A0 
//=====================================================================================
void ISR_HwI2c(void) 
{
#if 0
	SBUF = rI2C_STA;
	while(TI==0);
	TI=0;
#endif
	


	//Slave mode
	//check READ or WRITE
	if(rI2C_STA & SI2C_ALRW)	// Read Mode
	{
		//Slave + READ
		//check ACK
		if((rI2C_STA & 0x21) == 0)		// Check Not NACK & STOP
		{   
			rFIFO_DAT = *SubAddr_Table[++SubAddr];	// TX
			rI2C_CLR = SIIC_CLR_RT+ SIIC_CLR_RSTR;
		}
		else 
		{
			rI2C_CLR = (SIIC_CLR_RT + SIIC_CLR_STOP );
			RevSlave = 0;
		}
	}
 	else
	{
	//Slave + WRITE
	//check FIRST
		if(rI2C_STA & SI2C_FIRST)	   	
		{ 
			rI2C_CLR = (SIIC_CLR_RT);	//clear interrupt																	
			RevSlave = 1;

		}
		
      		else if(rI2C_STA & SI2C_RT9BIT)   
		{
			if(RevSlave == 1)			 //rI2C_STA = 0xC0
			{
				SubAddr = rFIFO_DAT;   	// put Subaddress
				rI2C_CLR = SIIC_CLR_RT;	// clear interrupt
				rFIFO_CLR |=0x80;	    	//clear TXFIFO index
				rFIFO_DAT = *SubAddr_Table[SubAddr]; //put the data into fifo
				RevSlave = 2;
			}
         		else if(RevSlave > 1)			     	//rI2C_STA = 0xC0
			{
				*SubAddr_Table[SubAddr] = rFIFO_DAT; 
				rI2C_CLR = SIIC_CLR_RT;																	
				switch(SubAddr++)
	             	 	{
               			case 0x00:  break;
					case 0x01:  break;
					case 0x02:  break;
					case 0x03:  break;
					case 0x04:  break;
					case 0x05:  break;
					case 0x06:  break;
					case 0x07:  break;
					case 0x08:  break;
					case 0x09:  break;
					case 0x0A:  break;
					case 0x0B:  break;
					case 0x0C:  break;
					case 0x0D:  break;
					case 0x0E:  break;
					case 0x0F:  break;
										
					case 0x10: 	break;
					case 0x11:  break;	
			   		case 0x12:	break;
					case 0x13:  break;
               			case 0x14: 	IR_EN_FLAG = 1; break;
					case 0x15:  IR_EN_FLAG = 1; break;
					case 0x16:  break;
					case 0x17:  break;
					case 0x18:  break;
					case 0x19:  break;
					case 0x1A:  break;
					case 0x1B:  break;
					case 0x1C:  break;
					case 0x1D:  break;
					case 0x1E:  break;
					case 0x1F:  break;
					case 0x20:  break;
											
					case 0x21:  break;
            	  			case 0x22:  break;
	              		case 0x23:  break;
	               		case 0x24:  break;
	               		case 0x25:  break;
	               		case 0x26:  break;
	               		case 0x27:  break; 
					case 0x28:  break;
					case 0x29:  break;
					case 0x2A:  break;
					
					case 0x2B:  RTC_SEC_FLAG = 1; 	API_UpdateRtc(); break;
					case 0x2C:  RTC_MIN_FLAG = 1; 	API_UpdateRtc(); break;
					case 0x2D:  RTC_HOUR_FLAG = 1; 	API_UpdateRtc(); break;
					case 0x2E:  RTC_DAY_FLAG = 1; 	API_UpdateRtc(); break;											

					case 0x2F: 	RTC_WEEK_FLAG = 1; 	API_UpdateRtc(); break;
	            	  		case 0x30: 	RTC_MONTH_FLAG = 1; API_UpdateRtc(); break;
	              		case 0x31: 	RTC_YEAR_FLAG = 1; 	API_UpdateRtc(); break;
					
	               		case 0x32: 	break;
	               		case 0x33: 	break;
	               		case 0x34: 	break;
	               		case 0x35:	break;
			   		case 0x36:	break;
					case 0x37:  break;
					case 0x38:  break;
					case 0x39:  break;
					case 0x3A:  break;
					case 0x3B:  break;											
					case 0x3C:  break;
					case 0x3D:  break;
				
										
         			default:break;
              	}  
               	RevSlave = 3;
        	}
        }
      	else	// STOP
        { 
		
        	rI2C_CLR = (SIIC_CLR_RT + SIIC_CLR_STOP );	 							
	      	RevSlave = 0;
		   
        }
    }
}
//====================================================
#endif

