//=====================================================================================
#include "gheader.h"
//=====================================================================================
#ifdef ENABLE_IR_MODE
//=====================================================================================
static idata DWORD  ir_data;
static idata DWORD  ir_code;
static data BYTE   ir_stat, ir_key0,ir_key1,ir_key2,ir_key3, ir_idle_time;		//Don't change idata

static bdata bit   ir_actived ,ir_received ,ir_clock_hl , ir_TR_stat , ir_bit_value;
static idata BYTE  ir_pwr_time, ir_header_cnt;
bdata bit 			ir_receive_flag , rc6_header_flag;
BYTE				rc6_mode;						//20061215

//=====================================================================================
//
//=====================================================================================
void DRV_IrInitial(void)
{
 	//Init H/W IR function.
  GPIO_IR_IO_FUN_EN = GPIO_INPUT_MODE;    //Set I/O to INPUT mode.
 	
	 rIR_CTL = (0x81
           | (HW_IR_SEDG << 6)						//default=1
           | (HW_IR_EDGE_TYPE << 5)				//default=0
           | (HW_IR_OV_INT << 4)					//default=1
           | (HW_IR_PRE_SCAL << 1));			//default=0,64uS												//
  ir_stat = IR_IDLE;											//default=0

  ir_received = OFF;										//default=0,finish flag	
  ir_actived = OFF;											//default=0		
  ir_pwr_time = 0;

  #if(IR_TARGET==ACTIVE_INT0)
  //Ir interrupt from INT0
  INT0_CTL_IR_EN = 1;  					//Enable H/W IR interrupt.
  HW_IR_CTL_CLR_INT = 1;				//Clear H/W IR interrupt
  EX0 = 1;    							//Enable interrupt 0
  #endif
  #if(IR_TARGET==ACTIVE_INT1)
  //Ir interrupt from INT1
  INT1_CTL_IR_EN = 1;  					//Enable H/W IR interrupt.
  HW_IR_CTL_CLR_INT = 1;				//Clear H/W IR interrupt
  EX1 = 1;    							//Enable interrupt 1
  #endif
	


}
//=====================================================================================
//
//=====================================================================================
void IR_PWR_DOWN_EN_CHK(void)
{
	if(ir_pwrdown_en)							//SubAddr=0x11,Bit5
	{
#if(IR_TARGET==ACTIVE_INT0)
		INT0_CTL_IR_EN = 1;  					//Enable H/W IR interrupt from INT0.
#else
		INT1_CTL_IR_EN = 1;  					//Enable H/W IR interrupt from INT1.
#endif
	}
	else
	{
#if(IR_TARGET==ACTIVE_INT0)
		INT0_CTL_IR_EN = 0;  					//Disble H/W IR interrupt from INT0.
#else
		INT1_CTL_IR_EN = 0;  					//Disble H/W IR interrupt from INT1.
#endif
	}
}
//=====================================================================================
//
//=====================================================================================

void IR_WAKE_UP_EN_CHK(void)
{
	if(ir_wakeup_en)								//SubAddr=0x10,Bit5
	{
#if(IR_TARGET==ACTIVE_INT0)
		INT0_CTL_IR_EN = 1;  					//Enable H/W IR interrupt from INT0.
#else
		INT1_CTL_IR_EN = 1;  					//Enable H/W IR interrupt from INT1.
#endif
	}
	else
	{
#if(IR_TARGET==ACTIVE_INT0)
		INT0_CTL_IR_EN = 0;  					//Disble H/W IR interrupt from INT0.
#else
		INT1_CTL_IR_EN = 0;  					//Disble H/W IR interrupt from INT1.
#endif
	}
}
//=====================================================================================
//
//=====================================================================================
#if(HW_IR_DATA_TYPE == NEC_TYPE)
void HW_IR_NEC_TYPE_routine(void) 
{
	BYTE ir_count; 			

	ir_idle_time = 11; // 110ms	
	//ir_count =  rIR_CNT; 	

	///*  	
	if((HW_IR_STA_OVFLW == 1) || (rIR_CNT == 0xFF))		//Check IR Over flow interrupt 
	{																									//or IR counter low byte
		ir_stat = IR_IDLE;
		ir_data = IR_KEY_NULL;	
	}
	else  //start to receive data
	{
		ir_count =  rIR_CNT; //read counter				
		if(ir_stat == IR_IDLE)
		{		
																								//Check head (9mS+4.5mS)/256uS
			if((ir_count >= (IR_LEAD_CNT-LEAD_TOLERANCE)) && ir_count <= ((IR_LEAD_CNT+LEAD_TOLERANCE))) //check leading bit
			{
				//receive Leader code
				ir_data = IR_KEY_NULL;
				ir_stat = IR_DATA_BIT0;							
			}																												
																				//Check repeat code (9mS+2.5mS)/256uS			
			else if((ir_count >= (IR_REP_CNT-REP_TOLERANCE)) && ir_count <= ((IR_REP_CNT+REP_TOLERANCE)))// check repeat bit
			{
			//receive Repeat code					
				ir_stat = IR_IDLE;
			}
			else
			{			
			}
		}
		else
		{
			ir_data <<= 1;				//shift left 1bit										
			if((ir_count >= (IR_DATA1_CNT-DATA1_TOLERANCE) )&& (ir_count <= (IR_DATA1_CNT+DATA1_TOLERANCE)))//check hi bit
			{
				ir_data |= 1;
			}
			ir_stat++;

			if(ir_stat > IR_DATA_BIT31)	//check all data format
			{
				ir_received = ON;			
				ir_key0 = ir_data >> 24; 
				ir_key1 = ir_data >> 16; 
				ir_key2 = ir_data >> 8; 
				ir_key3 = ir_data & 0xFF; 

#if IR_SELF_TEST
#if(IR_TARGET==ACTIVE_INT0)	
				fSystemIrInt0Event = 1;
#endif
#if(IR_TARGET==ACTIVE_INT1)	
				fSystemIrInt1Event = 1;
#endif
#endif

				ir_stat = IR_IDLE;			

			}
		}

	}
	//Clear H/W IR interrupt
	HW_IR_CTL_CLR_INT = 1;
}
//=====================================================================================
//
//=====================================================================================
#elif(HW_IR_DATA_TYPE == RC5_TYPE)
void HW_IR_RC5_TYPE_routine(void) 	
	{
		BYTE ir_count,ir_period,ir_periodvalue,ir_index;  	
	//	WORD ir_code;  	

		ir_idle_time = 11 ;//20060224 110ms			
		ir_count =  rIR_CNT;   

//Add check ir_count==0xff	
//clear RC5  unstable bug 2007/08/31	
		if(ir_stat == IR_IDLE || ir_count == 0xFF)	//Start bit
		{
		ir_stat = IR_DATA_BIT0;
		ir_data = 0;
		}
		else
		{
			
			
			if(ir_count >= (IR_1PERIOD_CNT-IR_1PERIOD_TOLERANCE) && ir_count <= (IR_1PERIOD_CNT+IR_1PERIOD_TOLERANCE) ) 
			{
				ir_period = 1;
				if(ir_clock_hl) //High, data need reverse
					ir_periodvalue = 0;	//H
				else //Low, data need reverse
					ir_periodvalue = 1; //L
			}
			 else //if(ir_count >= (IR_2PERIOD_CNT-IR_2PERIOD_TOLERANCE))
			{
				ir_period = 2;
				if(ir_clock_hl) //High, data need reverse
					ir_periodvalue = 0;//HH
				else //Low, data need reverse
					ir_periodvalue = 3;//LL
			}
			ir_stat += ir_period;
			ir_data <<= ir_period;
			ir_data += ir_periodvalue;
			//ir_data <<= ir_period;
			
		}
		if(ir_stat == IR_DATA_BIT26 && HW_IR_STA_HL) //27
		//if(ir_stat == IR_DATA_BIT26 && GPIO_IR) //27
		{
			
			ir_stat = IR_DATA_BIT27;
			ir_data <<= 1;
			ir_data += 0;
		}	
//=============================================================			
		//IR transmitted finish
		if(ir_stat == IR_DATA_BIT27) //28
		{
			ir_code = 0x000;
			for(ir_index=0; ir_index < IR_DATA_BIT27/2; ) // 14
			{
				ir_code >>= 1;
				if((ir_data & 0x03) == 1) // 1
					ir_code |= 0x2000;
				ir_data>>= 2; 
				ir_index++;	   
			}
			
			//if(((ir_code>>6) & 0x1F) == IR_CUSTOM_CODE)
			//{
				ir_key2 = (BYTE) (ir_code & 0x3F);
				if((ir_code>>12) ==2)
					ir_key2 = ir_key2+64;
				
				ir_received = ON;				
				ir_key0 = ((ir_code>>6) & 0x1F); 	//customer code		
				ir_stat = IR_IDLE;
				ir_data = IR_KEY_NULL;
			//}
		ir_stat = IR_IDLE;			//BY steven liu	20060420
		ir_key1=~ir_key0;
		ir_key3=~ir_key2;
				



		}
		ir_clock_hl = HW_IR_STA_HL;
		//ir_clock_hl = GPIO_IR;
		//Clear H/W IR interrupt
		HW_IR_CTL_CLR_INT = 1;
	}
//==============================================================================
//==============================================================================  RC6
#elif(HW_IR_DATA_TYPE == RC6_TYPE)
void HW_IR_RC6_TYPE_routine(void) 	
{
		BYTE ir_count;//ir_index;//,ir_period,ir_periodvalue; 
	//	WORD ir_code;  	

		ir_idle_time = 11 ;//20060224 110ms
			
  if((HW_IR_STA_OVFLW == 1) || (rIR_CNT == 0xFF))		//Check IR Over flow interrupt 
  {																									//or IR counter low byte
    ir_stat = IR_IDLE;
    ir_data = IR_KEY_NULL;
  }
  else
  {
		ir_count =  rIR_CNT;   	
		if(ir_stat == IR_IDLE)	//Leader bit falling edge
		{
			ir_bit_value = 0;
			rc6_header_flag = 0;
			rc6_mode = 0x00;									//20061215
			//header 
			if((ir_count >= (IR_LEAD_CNT-LEAD_TOLERANCE)) && (ir_count <= (IR_LEAD_CNT+LEAD_TOLERANCE)))
			{
				 //receive Leader code
			 	ir_data = IR_KEY_NULL;					//0x00
			    ir_stat = IR_DATA_BIT0;					//1
				ir_header_cnt = 0;
				rc6_header_flag = 1;
		    }				
		}
		else
		{	
			if(ir_header_cnt <= 7)	//header code
			{
				if(ir_header_cnt <= 6)
				{
//----------------------------------------------------------------------

						if( ((ir_count >= (IR_1PERIOD_CNT-IR_1PERIOD_TOLERANCE)) && (ir_count <= (IR_1PERIOD_CNT+IR_1PERIOD_TOLERANCE)))  )
						{		//0.44us wide
							ir_header_cnt++;
						}
						else if((ir_count >= (IR_2PERIOD_CNT-IR_2PERIOD_TOLERANCE)) && (ir_count <= (IR_2PERIOD_CNT+IR_2PERIOD_TOLERANCE))) 
						{		//0.88us wide
							ir_header_cnt++;
							rc6_mode  ++;									//20061215
						}
						else
						{

						    ir_stat = IR_IDLE;
   							ir_data = IR_KEY_NULL;
						}
//----------------------------------------------------------------------
				}
				else
				{
					ir_header_cnt++;
		
					if((ir_count >= (IR_TR_CNT-TR_TOLERANCE)) && (ir_count <= (IR_TR_CNT+TR_TOLERANCE)))
					{
						ir_TR_stat = 1;								// TR __|--
						ir_header_cnt += 2;							//hcount
					}
					else
					{
						ir_TR_stat = 0;								// TR --|__
					}
				}
			}
			else    //control and information code
			{
				ir_header_cnt++;								
				//ir_test =	HW_IR_STA_HL  ;   		//for test
				if(ir_header_cnt >= 12)
				{	
					ir_stat++;
					if((ir_count >= (IR_1PERIOD_CNT-IR_1PERIOD_TOLERANCE)) && (ir_count <= (IR_1PERIOD_CNT+IR_1PERIOD_TOLERANCE)) ) 

					{								//0.44ms
						if(ir_bit_value == 0)
						{	
							if(ir_clock_hl == 1)		// data
							{
								ir_data <<= 1;
								ir_data += 0;
							}
						}
						else
						{
							if(ir_clock_hl == 0)		// data
							{
								ir_data <<= 1;
								ir_data += 1;
								if(ir_stat == IR_DATA_BIT29 ) 	//30  IF Last bit = 1 , add once count
									ir_stat++;
							}
						}
					}
					 else if(ir_count >= (IR_2PERIOD_CNT-IR_2PERIOD_TOLERANCE) && ir_count <= (IR_2PERIOD_CNT+IR_2PERIOD_TOLERANCE) ) 									
					{								// 0.88ms
						ir_stat++;						//add once count
						ir_bit_value =~ ir_bit_value;
						if(ir_bit_value == 1)
						{
							if(ir_clock_hl == 0)		// data
							{
								ir_data <<= 1;
								ir_data += 1;
								if(ir_stat == IR_DATA_BIT29 ) 	//30  IF Last bit = 1 , add once count
									ir_stat++;
							}
						}
						else
						{
							if(ir_clock_hl == 1)		// data
							{
								ir_data <<= 1;
								ir_data += 0;
							}
						}
					}
					else			//9/27 add
					{
					    ir_stat = IR_IDLE;
   						ir_data = IR_KEY_NULL;
					}

				}
			}

			//IR transmitted finish
//			if(ir_stat == IR_DATA_BIT30 && HW_IR_STA_HL)  //31
			if(ir_stat == IR_DATA_BIT30 )  //31				
			{

					ir_received = ON;									//IR finish 

	
					ir_key0 = ir_data >> 8; 
					ir_key2 = ir_data & 0xFF; 


					ir_key1=~ir_key0;
					ir_key3=~ir_key2;

				  ir_stat = IR_IDLE;
	   			ir_data = IR_KEY_NULL;
					rc6_header_flag = 0;

			}

		}
		ir_clock_hl = HW_IR_STA_HL;
	}
		//Clear H/W IR interrupt
		HW_IR_CTL_CLR_INT = 1;
}

//==============================================================================
//==============================================================================
#elif(HW_IR_DATA_TYPE == SONY_TYPE)
void HW_IR_SONY_TYPE_routine(void) 
{
	BYTE ir_count;
		
  ir_count =  rIR_CNT;   	//Get IR counter low byte	
  ir_idle_time = 11 ;//20060224 110ms
  //if((HW_IR_STA_OVFLW == 1) || (rIR_CNT == 0xFF))		//Check IR Over flow interrupt 
	if(ir_count == 0xFF)
  {																									//or IR counter low byte
    ir_stat = IR_IDLE;
    ir_data = IR_KEY_NULL;
  }
  else
  {
    
		 //rIR_CNT=0x00;
    if(ir_stat == IR_IDLE)
    {												//Check head (9mS+4.5mS)/64uS			
      if((ir_count >= (IR_LEAD_CNT-LEAD_TOLERANCE)) && ir_count <= ((IR_LEAD_CNT+LEAD_TOLERANCE)))
      {
        //receive Leader code
        ir_data = IR_KEY_NULL;
        ir_stat = IR_DATA_BIT0;
				
      }											//Check repeat code (9mS+2.5mS)/64uS
      //else if((ir_count >= (IR_REP_CNT-REP_TOLERANCE)) && ir_count <= ((IR_REP_CNT+REP_TOLERANCE)))
      //{
        //receive Repeat code
        //ir_key = (BYTE) (ir_data & 0xFF);
        //ir_stat = IR_IDLE;
     // }
      //else
      //{
      //}
    }
    else
    {
      ir_data <<= 1;					//shift left 1bit
															//(23+5)>ir_count>(23-5)
      if((ir_count >= (IR_DATA1_CNT-DATA1_TOLERANCE) )&& (ir_count <= (IR_DATA1_CNT+DATA1_TOLERANCE)))
      {
        ir_data |= 1;
      }
      ir_stat++;
			
      if(ir_stat > IR_DATA_BIT10)			//Check Receive 32Bit
      {
			
		
		
				//check IR=HI
				do
				{
				}
				while(GPIO_IR==0);		//1=>0:convert finish
      
				
				
				ir_count =  rIR_CNT;   	//Get IR counter low byte
				ir_data <<= 1;
				if(ir_count <= (IR_DATA0_CNT+DATA0_TOLERANCE))
      	{

				}
				else
				{
				ir_data |= 1;
				}

			ir_received = ON;									//IR finish 
	  ir_key0 = ir_data >> 24; 
		ir_key1 = ir_data >> 16; 
		ir_key2 = ir_data >> 8; 
		ir_key3 = ir_data & 0xFF; 

        

/*			
			if((ir_key0==0x00) && (ir_key1==0x00))
				{
				ir_key0=ir_key2;
				ir_key1=(~ir_key0);
				ir_key2=ir_key3;
				ir_key3=(~ir_key2);
			
//ir_key2=0x0A
//ir_key3=0x90
//0000 1010	==>0x0A
//1001 0000===>0x90
//DATA 7bit	001 0101====>15H
//Custom 5bit 00001	==>1

				}	
*/			
			ir_stat = IR_IDLE;	
			
			
		}
	}

  }
//Clear H/W IR interrupt
HW_IR_CTL_CLR_INT = 1;
}
#endif 
//=====================================================================================
//
//=====================================================================================

void IR_routine(void)
{
//BYTE i; 		
	if (ir_received) // IR receive data
	{
		if((ir_key0==0x00) && (ir_key1==0x00))// for sony format
		{
			ir_key0=ir_key2;
			ir_key1=(~ir_key0);
			ir_key2=ir_key3;
			ir_key3=(~ir_key2);	
		}	
		//=============for debug============
		#if(IR_TARGET==ACTIVE_INT0)
		DRV_PutStr("IR Interrupt using INT0\r\n");
		#endif
		#if(IR_TARGET==ACTIVE_INT1)
		DRV_PutStr("IR Interrupt using INT1 \r\n");
		#endif
		#ifdef ENABLE_UARTDEBUG_MODE	
	   	DRV_PutStr("IR Decode");	
		DRV_Printf(" ir_key0 = %x\n",ir_key0);
		DRV_Printf(" ir_key1 = %x\n",ir_key1);
		DRV_Printf(" ir_key2 = %x\n",ir_key2);
		DRV_Printf(" ir_key3 = %x\r\n",ir_key3);
		#endif
		//================================
	//debug can watch you IR custom & data code
#if 0
	*SubAddr_Table[0x10] = ir_key0; 		
	*SubAddr_Table[0x11] = ir_key1; 
	*SubAddr_Table[0x12] = ir_key2; 
	*SubAddr_Table[0x13] = ir_key3; 
#endif
		ir_received = OFF;
		if ((ir_key0 == ir_detectkey0) && (ir_key1 == ir_detectkey1) && (ir_key2 == ir_detectkey2) && (ir_key3 == ir_detectkey3))
		{
			//Check IR Key code Ok
			if (ON == ir_actived)	//Repeat
			return;
			ir_actived = ON;  
			if (ir_pwr_time == 0)
			{
				ir_pwr_time = 50;	// 500 MS	
				if (PowerStatus == PWR_ON) // check power status
					System_Power_OFF(HOST_PWRDOWN_VIA_IR);
				else
					System_Power_ON(HOST_WAKEUP_VIA_IR);  
			}
		//    ir_key = IR_KEY_NULL;
		}
	}
}
//=====================================================================================
void Ir_IdelTime(void)
{
	if(ir_idle_time)
    {
    	ir_idle_time--;
    	if(ir_idle_time == 0)
		{
       		ir_actived = OFF;	
			ir_key0 = 0;
			ir_key1 = 0;	
			ir_key2 = 0;
			ir_key3 = 0;
		}
   }	
 	if(ir_pwr_time)
    {
    	ir_pwr_time--;
    }    	
}
//=====================================================================================
#endif
