//=====================================================================================
#include "gheader.h"
//=====================================================================================

//Timer 0, 1, 2 clock base only 12T
//=====================================================================================
//Timer 0 is system timer base
//=====================================================================================
void OS_TimerInitial(void)
{
	
	TR0 = 0; 
	TMOD |= 0x01;
	TL0 = (65536 - OS_TIMER0_BASE) % 256;         				// Set timer value for 10ms interrupt.
	TH0 = (65536 - OS_TIMER0_BASE) / 256;						// 	
	
	rAUXR &= ~0x02;			//12T 
	//rAUXR |= 0x02;		//Enable Timer0 run 3T
	TR0=1;
	ET0 = 1; 	
    bOsTimer0Flag = 0;
	bOsTimer0Count = 0;
}
//=====================================================================================
//
//=====================================================================================
void Timer0_Interrupt (void) interrupt 1 //using 1
{
	TR0 = 0;
	TL0 = (65536 - OS_TIMER0_BASE) % 256;       // Set timer value for 10ms interrupt.
	TH0 = (65536 - OS_TIMER0_BASE) / 256;		// 
  	TR0 = 1;	
	bOsTimer0Count++;
	fSystemTimeEvent = 1;
}	

void Timer0Service(void)
{
	if(fSystemTimeEvent!=1) return;
	
	fSystemTimeEvent = 0;
	#if SLEEP_SELF_TEST
	if(PowerStatus == PWR_OFF)
	{
		PowerDownCounter++;
	}
	#endif

	if(((bOsTimer0Count / ROSC_POLL_TIME) > 0)
  	&& ((bOsTimer0Count % ROSC_POLL_TIME) == 0))
  	{
    	fRoscTimerEvent = 1;
  	}

	#ifdef ENABLE_APIAKEY_MODE
	if(((bOsTimer0Count / AKEYPAD_POLL_TIME) > 0)
  	&& ((bOsTimer0Count % AKEYPAD_POLL_TIME) == 0))
  	{
    	fAkeypadTimeEvent = 1;
  	}
	#endif

	#ifdef ENABLE_APIDKEY_MODE
	if(((bOsTimer0Count / KEYPAD_POLL_TIME) > 0)
  	&& ((bOsTimer0Count % KEYPAD_POLL_TIME) == 0))
  	{
    	fKeypadTimeEvent = 1;
  	}
	#endif
 
	if(((bOsTimer0Count / IR_POLL_TIME) > 0)
  	&& ((bOsTimer0Count % IR_POLL_TIME) == 0))
  	{
   		fIrTimerEvent = 1;
  	}
	if(((bOsTimer0Count / RTC_POLL_TIME) > 0)
  	&& ((bOsTimer0Count % RTC_POLL_TIME) == 0))
  	{
    	fAlarmTimer = 1;
  	}



#ifdef _ENABLE_ADC_TOUCH_	
	if(((bOsTimer0Count / TOUCH_COUNT_TIME) > 0)
  	&& ((bOsTimer0Count % TOUCH_COUNT_TIME) == 0))
  	{
		fGetTouchTime=TRUE;
  	}
#endif


	Ir_IdelTime();

	#ifdef ENABLE_APIDKEY_MODE
	DRV_DigitalKey10mS();
	#endif

	#ifdef ENABLE_APIAKEY_MODE
	DRV_AnalogKeyRelease10mS();	
	#endif
}
//=====================================================================================
//Timer 1 and Timer 2 Self Test
//=====================================================================================
#if TIMER_SELF_TEST
void OS_Timer12SelfTestInitial(void)
{

	OS_Timer1Initial();			//Set Timer1 10ms 
	OS_Timer2Initial();			//Set Timer2 10ms 
}
#endif
//=====================================================================================
//Initial timer1
//=====================================================================================
#if TIMER_SELF_TEST
void OS_Timer1Initial(void)
{
	
	TR1 = 0; 
	TMOD |= 0x10;
	TL1 = (65536 - OS_TIMER1_BASE) % 256;         				
	TH1 = (65536 - OS_TIMER1_BASE) / 256;
	
	TR1=1;
	ET1 = 1; 
	
	fSystemTimer1Event = 0;
	
}

void Timer1_Interrupt (void) interrupt 3 
{
	TR1 = 0;
	TL1 = (65536 - OS_TIMER1_BASE) % 256;         			
	TH1 = (65536 - OS_TIMER1_BASE) / 256;					 
    TR1 = 1;	
	
 	fSystemTimer1Event = 1;
	
 	   
				
}
#endif
//=====================================================================================
//Initial timer2
//=====================================================================================
#if TIMER_SELF_TEST
void OS_Timer2Initial(void)
{
	
	rTR2 = 0;
	rTF2 = 0; 	
	rTL2 = (65536 - OS_TIMER2_BASE) % 256;         				// Set timer value for 10ms interrupt.
	rTH2 = (65536 - OS_TIMER2_BASE) / 256;									 

	rRCAP2L = (65536 - OS_TIMER2_BASE) % 256;         				// Set timer value for 10ms interrupt.
	rRCAP2H = (65536 - OS_TIMER2_BASE) / 256;
	
	rTR2=1;
	ET2 = 1; 
	fSystemTimer2Event = 0;

}

void Timer2 (void) interrupt 5 
{
	rTF2 = 0;
	rTR2 = 0;
	//rTL2 = (65536 - OS_TIMER2_BASE) % 256;         				// Set timer value for 10ms interrupt.
	//rTH2 = (65536 - OS_TIMER2_BASE) / 256;					
	rTR2 = 1;	

	fSystemTimer2Event = 1;
	
	
}
#endif





























