//=====================================================================================
//=====================================================================================
#include "gheader.h"

#ifdef ENABLE_UART0_MODE	
/*
Serial Baud Rate Generator register. 
When SBRG_EN (SBRGH.7) is set to high, 
Baud rate, UART1 = Fosc/(16 * rSBRGH + (rSBRGL/16)) 
*/
#define UART0_2400			OFF		//OK	
#define UART0_9600			OFF		//OK
#define UART0_19200			OFF		//OK
#define UART0_57600			OFF		//OK
#define UART0_115200		ON		//OK
#define UART0_230400		OFF  
#define UART0_256000		OFF   // this baud rate has 0.26% error rate
#define UART0_460800		0FF  //untest

#if(UART0_2400==ON)
	#define SRG_M	312 
	#define SRG_F	8
#elif(UART0_9600==ON)
	#define SRG_M	78 
	#define SRG_F	2
#elif(UART0_19200==ON)
	#define SRG_M	39 
	#define SRG_F	1
#elif(UART0_57600==ON)
	#define SRG_M	13 
	#define SRG_F	0
#elif(UART0_115200==ON)
	#define SRG_M	6  
	#define SRG_F	8
#elif(UART0_230400==ON)		    // 0.16%
	#define SRG_M	3  
	#define SRG_F	4
#elif(UART0_256000==ON)			// 0.26%
	#define SRG_M	2  
	#define SRG_F	15
#elif(UART0_460800==ON)
	#define SRG_M	1  
	#define SRG_F	10
#endif
//=====================================================================================
//
//=====================================================================================
void DRV_Uart0Inital(void)
{
//Set baud rate 115200,n,8,1	
	SCON = 0x50;  //Mode1,8-bit,REN=1
	rSBRGH |= 0x80;
	rSBRGH |= (SRG_M / 16);
	rSBRGL |= (((SRG_M % 16) * 16) + SRG_F);
	//rSBRGL |= 0x08;		
	//rSBRG0 = 78;						//rSBRG0[6:0]=0x0C	for 12Mhz    Baud rate=115200					
	PCON |= 0xC0;						////Set buad rate=1/8*(Fosc/(rSBRG0[6:0]+1)) 	
	rGPIO_CTL0|=0x10;		//Enable UAER 1 IO pad

	#if UART0_SELF_TEST
	ES = 1;
	#endif
}



//=====================================================================================
//
//=====================================================================================
void UART0_interrupt (void) interrupt 4 
{
	#if UART0_SELF_TEST	
	if(RI)
	{   		
		if(fSystemUart0RxEvent==1) RI = 0;
		SelfTestRxData[SelfTestIndex] = SBUF;
		RI=0;
		SelfTestIndex++;

		if(SelfTestIndex==SELF_TEST_LENGTH)
		{
			fSystemUart0RxEvent = 1;
			SelfTestIndex = 0;
		}

		if(SelfTestRxData[0]==EXIT_SELF_TEST_CMD)
		{
			//Reset MCU
			//Disable Watch Dog
			rWATCHDOG |= 0x80;
			//Enable Watch Dog
			rWATCHDOG &= 0x7F;			// Enable Watchdog Timer , then set Watch dog reset time
			rWDT_RST = WD_RST_TIME_33MS;			
			DelayWhile(100);
		}			
	}
	#else
	if(RI)
	{   		
		RI=0;	
	}
	if(TI)
 	{
		TI = 0;			
	}	
	#endif


	
	

	
}

#endif
