//=====================================================================================
#include "gheader.h"
//=====================================================================================

#ifdef ENABLE_UART1_MODE	

/*
Serial Baud Rate Generator register. 
When SBRG_EN (SBRGH.7) is set to high, 
Baud rate, UART1 = Fosc/(16 * rSBRGH + (rSBRGL/16)) 
*/
#define UART1_2400			OFF
#define UART1_9600			OFF
#define UART1_19200			OFF
#define UART1_57600			OFF
#define UART1_115200		ON
#define UART1_230400		OFF  //untest



#if(UART1_2400==ON)
	#define SRG1_M	312 
	#define SRG1_F	8
#elif(UART1_9600==ON)
	#define SRG1_M	78 
	#define SRG1_F	2
#elif(UART1_19200==ON)
	#define SRG1_M	39 
	#define SRG1_F	1
#elif(UART1_57600==ON)
	#define SRG1_M	13 
	#define SRG1_F	0
#elif(UART1_115200==ON)
	#define SRG1_M	6  
	#define SRG1_F	8
#elif(UART1_230400==ON)
	#define SRG1_M	3  
	#define SRG1_F	4
#endif
//=====================================================================================
//=====================================================================================
#if(UART_DEBUG_PORT==UART1)
void DRV_Uart1Initial(void)
{
	//Set baud rate 115200,n,8,1 using SBRG 		
	rSCON1 = 0x50;  //Mode1,8-bit,REN=1
	rSBRG1H |= 0x80;
	rSBRG1H |= (SRG1_M / 16);
	rSBRG1L |= (((SRG1_M % 16) * 16) + SRG1_F);  		
					
	PCON |= 0xC0;			//Set buad rate=1/8*(Fosc/(rSBRG0[6:0]+1)) 	
	rGPIO_CTL3 |= 0x40;		//Enable UAER 1 IO pad		

	#if UART_SELF_TEST
	ES1 = 1;
	#endif
}
#endif


void UART_interrupt (void) interrupt 6 
{

	
	
	if(RI_1)
 	{
		
		
		#if UART_SELF_TEST
		Uart1RxData = rSBUF1;
 		RI_1=0;
		fSystemUart1RxEvent = 1;
		#else
		RI_1=0;
		#endif

	}	

	#if UART_SELF_TEST
	if(TI_1)
 	{
		fSystemUart1TxEvent = 1;		
	}
	#endif
/*	
	if(TI_1)
	{	
		TI_1=0;
	}
*/		
}

#endif
