#ifndef OPTION_H
#define OPTION_H
//=========================================================
//#define _ENABLE_ADC_TOUCH_
//===========ROSC MODE===========================
//RC Osc calibration	  
#define EXTERNAL_32K			OFF
#define REF_OSC_CAL_VALUE       (WORD)(XTAL_12M/(32768))
#define OSC_CAL_RANGE           4
#define ROSC_DEFAULT_12MHZ		53	//One sample
#define LDO_DEFAULT_18V		    17  //One sample
	
//#define OSC_CAL_RETRY_CNT       1
//#define OS_VERSION              1
//#define OS_POLL_TIME            20
//#define OS_HOST_COMM_IF         HW_I2C
//===========WATCH DOG MODE======================
#define OS_Reset_WD()           {rWDT_RST = WD_RST_TIME_2S; rWDT_DET = WD_DET_TIME_5S;}
#define ACTIVE_WD_TIMER         ON  
#define OS_WD_FUN_DIS           DefineBit(rWATCHDOG, bit7)   //Disable Watchdog function


//===========SELF TEST MODE======================
#define SELF_TEST_LENGTH	3
#define	SYSTEM_SELF_TEST			0
	#define UART0_SELF_TEST			0
	#define UART_SELF_TEST			0
	#define	EXIT_SELF_TEST_CMD		'0'
		//Keyin 000	select ReStart MCU
	#define	SPI_SELF_TEST_CMD		'2'
		//Keyin 200	select SPI as Master
		//Keyin 211	select SPI as Slave
	#define	TIMER_SELF_TEST_CMD		'3'
		//Keyin 300	select Timer 1 GPIOC5/PWM0 output pluse 50ms 
		//Keyin 300	select Timer 2 GPIOA45/PWM3 output pluse 100ms 
	#define	PWM_SELF_TEST_CMD		'4'
		//Keyin 400	select PWM 0,1,2,3 as 8 bit
		//Keyin 411	select PWM 0,1,2,3 as 10 bit
	#define	ADC_SELF_TEST_CMD		'5'
		//Keyin 500	select Channel 0 / GPIOB0
		//keyin 511 select Channel 1 / GPIOB1
		//keyin 522 select Channel 2 / GPIOB2
		//keyin 533 select Channel 3 / GPIOB3
		//keyin 544 select Channel 4 / GPIOB4
		//keyin 555 select Channel 5 / GPIOB5
		//keyin 566 select Channel 6 / GPIOB6
		//keyin 577 select Channel 7 / GPIOB7	
		//keyin 588 Read Internal Temp Sensor	
		//keyin 599 Analog Comparator
	#define	GPIO_SELF_TEST_CMD		'6'
		//Keyin 600	select 1sec
		//keyin 611 select 2sec
		//keyin 622 select 33ms
		//keyin 633 select 65ms
		//keyin 644 select 8sec	
	#define	WDT_SELF_TEST_CMD		'7'
		//Keyin 700	select 1sec
		//keyin 711 select 2sec
		//keyin 722 select 33ms
		//keyin 733 select 65ms
		//keyin 744 select 8sec	
		//Detect Watch Dog
		//keyin 755 select 1sec	
		//keyin 766 select 2sec	
		//keyin 777 select 52sec	
	#define RCOSC_SELF_TEST_CMD		'8'
		//Keyin 800	select 32.768khz
		//keyin 811 select RC 12MHZ
		//keyin 822 select RC 6MHZ
		//keyin 833 select RC 3MHZ
		//keyin 844 select RC 1MHZ
		//keyin 855 select RC 128KHZ
		//keyin 866 select RC 16MHZ
		//keyin 877 select RC 8MHZ	
	#define MEM_SELF_TEST_CMD		'9'
			//Keyin 911	test xdata
			//Keyin 922	test idata 

	//#define XDATA_SELF_TEST_CMD		'9'
	
		#define SPI_SELF_TEST		0		// Cmd is '2'
		#define TIMER_SELF_TEST		0		// Cmd is '3'
		#define PWM_SELF_TEST		0		// Cmd is '4'
		#define ADC_SELF_TEST		0		// Cmd is '5'	
		#define GPIO_SELF_TEST		0		// Cmd is '6'	
		#define	WDT_SELF_TEST		0		// Cmd is '7'
		#define	DWDT_SELF_TEST		0		// Cmd is '7'
		#define RCOSC_SELF_TEST		0		// Cmd is '8'
		#define MEM_SELF_TEST		0		// Cmd is '9'



	#define TEMP_SELF_TEST				0
	
	
	
	#define INT0_SELF_TEST				0
	
	#define VDD_SELF_TEST				0
		
		#define LDO_DET_4V			0x07
		#define LDO_DET_3V75		0x06
		#define LDO_DET_3V5			0x05
		#define LDO_DET_3V25		0x04
		#define LDO_DET_3V			0x03
		#define LDO_DET_2V75		0x02
		#define LDO_DET_2V5			0x01
		#define LDO_DET_2V25		0x00

	#define UART_SELF_TEST			0
	#define IR_SELF_TEST			0
	#define SLEEP_SELF_TEST			0


//===========INTERRUPT MODE======================
#define ACTIVE_INT0		0x00
#define ACTIVE_INT1		0x01	
#define IR_TARGET		ACTIVE_INT0



//===========IR MODE=============================
#define ENABLE_IR_MODE
	 
#define NEC_TYPE                1
#define RC5_TYPE                2
#define RC6_TYPE                3
#define SHARP_TYPE              4
#define SONY_TYPE              	5
	
#define HW_IR_DATA_TYPE 		NEC_TYPE
//#define HW_IR_DATA_TYPE        RC5_TYPE
//#define HW_IR_DATA_TYPE        RC6_TYPE
//#define HW_IR_DATA_TYPE        SONY_TYPE

#define IR_CUSTOM_CODE  0x55
#define IR_DETECT_KEY	0xFF

//===========ROSC MODE====================
#define ROSC_POLL_TIME		  20	//Base on 200ms

//===========RTC MODE====================
#define ENABLE_RTC_MODE	
#define ENABLE_APIRTC_MODE		
#define RTC_POLL_TIME         50    //Base on 500ms

//==========8051 P0 MODE==================
#define ENABLE_8051PORT0_MODE

//===========UART debug MODE====================
#define ENABLE_UARTDEBUG_MODE

#define UART0		0
#define UART1		1

#define UART_DEBUG_PORT		UART0

//===========UART0 MODE====================
#define ENABLE_UART0_MODE


//===========UART1 MODE====================
//#define ENABLE_UART1_MODE


//===========I2C MODE====================
#define ENABLE_I2C_MODE

//===========APIDKEY MODE====================
#define ENABLE_APIDKEY_MODE   
#define	KEYPAD_POLL_TIME	2 		//Dkey Scan times

//===========AKEY MODE====================
#define ENABLE_APIAKEY_MODE   
#define	AKEYPAD_POLL_TIME	2 //50		//Akey Scan times  


#define ENABLE_ADC_MODE
#ifdef _ENABLE_ADC_TOUCH_
//===========TOUCH MODE================
#define TOUCH_COUNT_TIME  2
#endif
//===========Analoag ompareKEY MODE====================
//#define ENABLE_ACOMP_MODE   
//#define ENABLE_ATEMPP_MODE


//===========DRV EEPROM MODE====================
//#define ENABLE_EEPROM_MODE 

//===========DRV FLASH MODE====================
//#define ENABLE_FLASH_MODE 

//===========DRV CTOUCH MODE====================
//#define ENABLE_CTOUCH_MODE 

//===========DRV SPI MODE====================
#define ENABLE_SPI_MODE

//====================================================
#define LED_DEBUG	1
#endif