//=====================================================================================
#include "gheader.h"
//=====================================================================================

 

#if(XFR_USEING==XDATA_FOR_XFR)
// System Level Register
xdata BYTE rCHIP_ID       _at_ 0x0000;  // R
xdata BYTE rSYS_CTL1      _at_ 0x0001;  // RW
xdata BYTE rSYS_CTL2      _at_ 0x0002;  // RW

// Watchdog Timer 
xdata BYTE rWATCHDOG      _at_ 0x0008;  // RW
xdata BYTE rWDT_RST       _at_ 0x0009;  // RW
xdata BYTE rWDT_DET       _at_ 0x000A;  // RW


xdata BYTE rLVD_SEL       _at_ 0x000B;  // RW

// Calibrate VDD3.3 & VDD 1.8V
xdata BYTE rLDO_DATA       _at_ 0x000E;  // RW
xdata BYTE rPD_SEL         _at_ 0x000F;  // RW
// GPIO
xdata BYTE rGPIOA_OEN     _at_ 0x0010;  // RW
xdata BYTE rGPIOB_OEN     _at_ 0x0011;  // RW
xdata BYTE rGPIOC_OEN     _at_ 0x0012;  // RW 

xdata BYTE rGPIOA_DAT     _at_ 0x0013;  // RW
xdata BYTE rGPIOB_DAT     _at_ 0x0014;  // RW
xdata BYTE rGPIOC_DAT     _at_ 0x0015;  // RW 

xdata BYTE rGPIOA_PHN     _at_ 0x0016;  // RW
xdata BYTE rGPIOB_PHN     _at_ 0x0017;  // RW
xdata BYTE rGPIOC_PHN     _at_ 0x0018;  // RW

xdata BYTE rGPIOA_TPY     _at_ 0x0019;  // RW
xdata BYTE rGPIOB_TPY     _at_ 0x001A;  // RW
xdata BYTE rGPIOC_TPY     _at_ 0x001B;  // RW

xdata BYTE rGPIO_CTL0     _at_ 0x001C;  // RW 
xdata BYTE rGPIO_CTL1     _at_ 0x001D;  // RW		ADC 0~7 enable io pad 
xdata BYTE rGPIO_CTL2     _at_ 0x001E;  // RW		SCAN 0~7 enable io pad
xdata BYTE rGPIO_CTL3     _at_ 0x001F;  // RW

//Wake-up & toggle Register
xdata BYTE rWK_CTL0       _at_ 0x0020;  // RW
xdata BYTE rWK_CTL1       _at_ 0x0021;  // RW
xdata BYTE rWK_CTL2       _at_ 0x0022;  // RW
xdata BYTE rWK_CTL3       _at_ 0x0023;  // RW
xdata BYTE rTOG_CTL0      _at_ 0x0024;  // R
xdata BYTE rTOG_CTL1      _at_ 0x0025;  // R
xdata BYTE rTOG_CTL2      _at_ 0x0026;  // R
xdata BYTE rTOG_CTL3      _at_ 0x0027;  // R
xdata BYTE rTOG_CTL4      _at_ 0x0028;  // R

// RC oscillator calibration
xdata BYTE rOSC_RCH       _at_ 0x002A;  // R
xdata BYTE rOSC_RCL       _at_ 0x002B;  // R
xdata BYTE rOSC_IADJ0     _at_ 0x002C;  // RW



              

// 8051 Interrupt 1
xdata BYTE rINT0_CTL0     _at_ 0x0030;  // RW
xdata BYTE rINT0_CTL1     _at_ 0x0031;  // RW
xdata BYTE rINT1_CTL0     _at_ 0x0032;  // RW
xdata BYTE rINT1_CTL1     _at_ 0x0033;  // RW


xdata BYTE rINT0_FLAG0    _at_ 0x0034;  // R
xdata BYTE rINT0_FLAG1    _at_ 0x0035;  // R
//pdata BYTE rINT1_FLAG0    _at_ 0x0036;  // R
//pdata BYTE rINT1_FLAG1    _at_ 0x0037;  // R
xdata BYTE rEVT_IRQ		_at_ 0x003A;
xdata BYTE rIRQ_CHG		_at_ 0x003B;
// SCAN C TOUCH
xdata BYTE rSMP_CNT_EN    _at_ 0x0040;  // RW
xdata BYTE rSMP_SCAN_TIME _at_ 0x0041;  // RW
xdata BYTE rSMP_EVENT     _at_ 0x0042;  // RW
xdata BYTE rSMP_EVENT1    _at_ 0x0043;  // RW
xdata BYTE rSMP_EVENT_CLR _at_ 0x0044;  // RW

xdata BYTE rSMP_THR_L     _at_ 0x0045;  // RW
xdata BYTE rSMP_THR_H     _at_ 0x0046;  // RW
xdata BYTE rSMP_CNT_L     _at_ 0x0047;  // RW
xdata BYTE rSMP_CNT_H     _at_ 0x0048;  // RW

xdata BYTE rSMP_I_SEL     _at_ 0x0049;  // RW
xdata BYTE rSMP_RC_PL     _at_ 0x004A;  // RW

// PWM
xdata BYTE rPWM_EN        _at_ 0x0050;  // RW
xdata BYTE rPWM_BAS       _at_ 0x0051;  // RW 
xdata BYTE rPWM0_CLK      _at_ 0x0052;  // RW
xdata BYTE rPWM1_CLK      _at_ 0x0053;  // RW 
xdata BYTE rPWM2_CLK      _at_ 0x0054;  // RW
xdata BYTE rPWM3_CLK      _at_ 0x0055;  // RW 

xdata BYTE rPWM0_DAL      _at_ 0x0056;  // RW
xdata BYTE rPWM0_DAH      _at_ 0x0057;  // RW 
xdata BYTE rPWM1_DAL      _at_ 0x0058;  // RW
xdata BYTE rPWM1_DAH      _at_ 0x0059;  // RW 
xdata BYTE rPWM2_DAL      _at_ 0x005A;  // RW
xdata BYTE rPWM2_DAH      _at_ 0x005B;  // RW 
xdata BYTE rPWM3_DAL      _at_ 0x005C;  // RW
xdata BYTE rPWM3_DAH      _at_ 0x005E;  // RW 


// Remote Control
xdata BYTE rIR_CTL        _at_ 0x0060;  // RW
xdata BYTE rIR_STA        _at_ 0x0061;  // R
xdata BYTE rIR_CNT        _at_ 0x0062;  // R
xdata BYTE rIR_FIT        _at_ 0x0063;  // RW



// FIFO
xdata BYTE rFIFO_CLR       _at_ 0x00A8;  // W
xdata BYTE rFIFO_TX_IDX    _at_ 0x00A9;  // R
xdata BYTE rFIFO_RX_IDX    _at_ 0x00AA;  // R
xdata BYTE rFIFO_DAT       _at_ 0x00AB;  // RW

// Master/Slave I2C Interface
xdata BYTE rI2C_CTL       _at_ 0x00A0;  // RW
xdata BYTE rI2C_NUM       _at_ 0x00A1;  // RW
xdata BYTE rI2C_CLR       _at_ 0x00A2;  // RW

xdata BYTE rI2C_STA       _at_ 0x00A3;  // R
xdata BYTE rI2C_SADR      _at_ 0x00A4;  // RW

// RTC(Real Time Clock)
xdata BYTE rRTC_CTL       _at_ 0x0038;  // R.W
xdata BYTE rRTC_SEC       _at_ 0x00B0;  // RW
xdata BYTE rRTC_MIN       _at_ 0x00B1;  // RW
xdata BYTE rRTC_HOUR      _at_ 0x00B2;  // RW
xdata BYTE rRTC_DAY       _at_ 0x00B3;  // RW
xdata BYTE rRTC_WEEK      _at_ 0x00B4;  // RW
xdata BYTE rRTC_MONTH     _at_ 0x00B5;  // RW
xdata BYTE rRTC_YEAR      _at_ 0x00B6;  // RW

xdata BYTE rRTC_BACKUP1   _at_ 0x00B8;  // RW
xdata BYTE rRTC_BACKUP2   _at_ 0x00B9;  // RW
xdata BYTE rRTC_BACKUP3   _at_ 0x00BA;  // RW
xdata BYTE rRTC_BACKUP4   _at_ 0x00BB;  // RW 

xdata BYTE rRTC_CA        _at_ 0x00BD;  // RW
xdata BYTE rRTC_OSC       _at_ 0x00BE;  // RW
xdata BYTE rRTC_MISC      _at_ 0x00BF;  // RW


xdata BYTE rEER_EN1       _at_ 0x00E0;  // W
xdata BYTE rEER_EN2       _at_ 0x00E1;  // W
xdata BYTE rEER_ADDRL     _at_ 0x00E2;  //RW		//bit 7-0
xdata BYTE rEER_ADDRH     _at_ 0x00E3;  //RW		//bit 11-8
xdata BYTE rEER_ERASE     _at_ 0x00E4;	//W
xdata BYTE rEER_DATA0     _at_ 0x00E8;  // W

// SPI
xdata BYTE rSPI_CTL       _at_ 0x00C0;  // RW
xdata BYTE rSPI_CR1       _at_ 0x00C1;  // RW
xdata BYTE rSPI_CR2       _at_ 0x00C2;  // RW
xdata BYTE rSPI_STA       _at_ 0x00C3;  // RW
xdata BYTE rSPI_BRS       _at_ 0x00C4;  // RW

// SPI FIFO
xdata BYTE rSPI_FIFO_CLR       _at_ 0x00C8;  // W
xdata BYTE rSPI_FIFO_TX_IDX    _at_ 0x00C9;  // R
xdata BYTE rSPI_FIFO_RX_IDX    _at_ 0x00CA;  // R
xdata BYTE rSPI_FIFO_DAT       _at_ 0x00CB;  // RW
// Low Speed ADC (for key scan)
xdata BYTE rADC_CTL       _at_ 0x00D0;  // RW
xdata BYTE rADC_DATAH     _at_ 0x00D1;  // R
xdata BYTE rADC_WKVH      _at_ 0x00D2;  // RW
xdata BYTE rADC_CHN       _at_ 0x00D3;  // RW
xdata BYTE rADC_DATAL     _at_ 0x00D4;  // R
xdata BYTE rADC_WKVL      _at_ 0x00D5;  // RW
xdata BYTE rADC_TMPS      _at_ 0x00D6;  // RW
xdata BYTE rADC_VREF      _at_ 0x00D7;  // RW

// Temperature sensor
xdata BYTE rPD_TMPS       _at_ 0x00D8;  // RW

// Ananlog Comparator
xdata BYTE rPD_ACOMP      _at_ 0x00D9;  // RW 
#endif
#if(XFR_USEING==PDATA_FOR_XFR)
// System Level Register
pdata BYTE rCHIP_ID       _at_ 0x0000;  // R
pdata BYTE rSYS_CTL1      _at_ 0x0001;  // RW
pdata BYTE rSYS_CTL2      _at_ 0x0002;  // RW

// Watchdog Timer 
pdata BYTE rWATCHDOG      _at_ 0x0008;  // RW
pdata BYTE rWDT_RST       _at_ 0x0009;  // RW
pdata BYTE rWDT_DET       _at_ 0x000A;  // RW


pdata BYTE rLVD_SEL       _at_ 0x000B;  // RW

// Calibrate VDD3.3 & VDD 1.8V
pdata BYTE rLDO_DATA       _at_ 0x000E;  // RW
pdata BYTE rPD_SEL         _at_ 0x000F;  // RW
// GPIO
pdata BYTE rGPIOA_OEN     _at_ 0x0010;  // RW
pdata BYTE rGPIOB_OEN     _at_ 0x0011;  // RW
pdata BYTE rGPIOC_OEN     _at_ 0x0012;  // RW 

pdata BYTE rGPIOA_DAT     _at_ 0x0013;  // RW
pdata BYTE rGPIOB_DAT     _at_ 0x0014;  // RW
pdata BYTE rGPIOC_DAT     _at_ 0x0015;  // RW 

pdata BYTE rGPIOA_PHN     _at_ 0x0016;  // RW
pdata BYTE rGPIOB_PHN     _at_ 0x0017;  // RW
pdata BYTE rGPIOC_PHN     _at_ 0x0018;  // RW

pdata BYTE rGPIOA_TPY     _at_ 0x0019;  // RW
pdata BYTE rGPIOB_TPY     _at_ 0x001A;  // RW
pdata BYTE rGPIOC_TPY     _at_ 0x001B;  // RW

pdata BYTE rGPIO_CTL0     _at_ 0x001C;  // RW 
pdata BYTE rGPIO_CTL1     _at_ 0x001D;  // RW		ADC 0~7 enable io pad 
pdata BYTE rGPIO_CTL2     _at_ 0x001E;  // RW		SCAN 0~7 enable io pad
pdata BYTE rGPIO_CTL3     _at_ 0x001F;  // RW

//Wake-up & toggle Register
pdata BYTE rWK_CTL0       _at_ 0x0020;  // RW
pdata BYTE rWK_CTL1       _at_ 0x0021;  // RW
pdata BYTE rWK_CTL2       _at_ 0x0022;  // RW
pdata BYTE rWK_CTL3       _at_ 0x0023;  // RW
pdata BYTE rTOG_CTL0      _at_ 0x0024;  // R
pdata BYTE rTOG_CTL1      _at_ 0x0025;  // R
pdata BYTE rTOG_CTL2      _at_ 0x0026;  // R
pdata BYTE rTOG_CTL3      _at_ 0x0027;  // R
pdata BYTE rTOG_CTL4      _at_ 0x0028;  // R

// RC oscillator calibration
pdata BYTE rOSC_RCH       _at_ 0x002A;  // R
pdata BYTE rOSC_RCL       _at_ 0x002B;  // R
pdata BYTE rOSC_IADJ0     _at_ 0x002C;  // RW



              

// 8051 Interrupt 1
pdata BYTE rINT0_CTL0     _at_ 0x0030;  // RW
pdata BYTE rINT0_CTL1     _at_ 0x0031;  // RW
pdata BYTE rINT1_CTL0     _at_ 0x0032;  // RW
pdata BYTE rINT1_CTL1     _at_ 0x0033;  // RW


pdata BYTE rINT0_FLAG0    _at_ 0x0034;  // R
pdata BYTE rINT0_FLAG1    _at_ 0x0035;  // R
//pdata BYTE rINT1_FLAG0    _at_ 0x0036;  // R
//pdata BYTE rINT1_FLAG1    _at_ 0x0037;  // R
pdata BYTE rEVT_IRQ		_at_ 0x003A;
pdata BYTE rIRQ_CHG		_at_ 0x003B;
// SCAN C TOUCH
pdata BYTE rSMP_CNT_EN    _at_ 0x0040;  // RW
pdata BYTE rSMP_SCAN_TIME _at_ 0x0041;  // RW
pdata BYTE rSMP_EVENT     _at_ 0x0042;  // RW
pdata BYTE rSMP_EVENT1    _at_ 0x0043;  // RW
pdata BYTE rSMP_EVENT_CLR _at_ 0x0044;  // RW

pdata BYTE rSMP_THR_L     _at_ 0x0045;  // RW
pdata BYTE rSMP_THR_H     _at_ 0x0046;  // RW
pdata BYTE rSMP_CNT_L     _at_ 0x0047;  // RW
pdata BYTE rSMP_CNT_H     _at_ 0x0048;  // RW

pdata BYTE rSMP_I_SEL     _at_ 0x0049;  // RW
pdata BYTE rSMP_RC_PL     _at_ 0x004A;  // RW

// PWM
pdata BYTE rPWM_EN        _at_ 0x0050;  // RW
pdata BYTE rPWM_BAS       _at_ 0x0051;  // RW 
pdata BYTE rPWM0_CLK      _at_ 0x0052;  // RW
pdata BYTE rPWM1_CLK      _at_ 0x0053;  // RW 
pdata BYTE rPWM2_CLK      _at_ 0x0054;  // RW
pdata BYTE rPWM3_CLK      _at_ 0x0055;  // RW 

pdata BYTE rPWM0_DAL      _at_ 0x0056;  // RW
pdata BYTE rPWM0_DAH      _at_ 0x0057;  // RW 
pdata BYTE rPWM1_DAL      _at_ 0x0058;  // RW
pdata BYTE rPWM1_DAH      _at_ 0x0059;  // RW 
pdata BYTE rPWM2_DAL      _at_ 0x005A;  // RW
pdata BYTE rPWM2_DAH      _at_ 0x005B;  // RW 
pdata BYTE rPWM3_DAL      _at_ 0x005C;  // RW
pdata BYTE rPWM3_DAH      _at_ 0x005E;  // RW 


// Remote Control
pdata BYTE rIR_CTL        _at_ 0x0060;  // RW
pdata BYTE rIR_STA        _at_ 0x0061;  // R
pdata BYTE rIR_CNT        _at_ 0x0062;  // R
pdata BYTE rIR_FIT        _at_ 0x0063;  // RW



// FIFO
pdata BYTE rFIFO_CLR       _at_ 0x00A8;  // W
pdata BYTE rFIFO_TX_IDX    _at_ 0x00A9;  // R
pdata BYTE rFIFO_RX_IDX    _at_ 0x00AA;  // R
pdata BYTE rFIFO_DAT       _at_ 0x00AB;  // RW

// Master/Slave I2C Interface
pdata BYTE rI2C_CTL       _at_ 0x00A0;  // RW
pdata BYTE rI2C_NUM       _at_ 0x00A1;  // RW
pdata BYTE rI2C_CLR       _at_ 0x00A2;  // RW

pdata BYTE rI2C_STA       _at_ 0x00A3;  // R
pdata BYTE rI2C_SADR      _at_ 0x00A4;  // RW

// RTC(Real Time Clock)
pdata BYTE rRTC_CTL       _at_ 0x0038;  // R.W
pdata BYTE rRTC_SEC       _at_ 0x00B0;  // RW
pdata BYTE rRTC_MIN       _at_ 0x00B1;  // RW
pdata BYTE rRTC_HOUR      _at_ 0x00B2;  // RW
pdata BYTE rRTC_DAY       _at_ 0x00B3;  // RW
pdata BYTE rRTC_WEEK      _at_ 0x00B4;  // RW
pdata BYTE rRTC_MONTH     _at_ 0x00B5;  // RW
pdata BYTE rRTC_YEAR      _at_ 0x00B6;  // RW

pdata BYTE rRTC_BACKUP1   _at_ 0x00B8;  // RW
pdata BYTE rRTC_BACKUP2   _at_ 0x00B9;  // RW
pdata BYTE rRTC_BACKUP3   _at_ 0x00BA;  // RW
pdata BYTE rRTC_BACKUP4   _at_ 0x00BB;  // RW 

pdata BYTE rRTC_CA        _at_ 0x00BD;  // RW
pdata BYTE rRTC_OSC       _at_ 0x00BE;  // RW
pdata BYTE rRTC_MISC      _at_ 0x00BF;  // RW


pdata BYTE rEER_EN1       _at_ 0x00E0;  // W
pdata BYTE rEER_EN2       _at_ 0x00E1;  // W
pdata BYTE rEER_ADDRL     _at_ 0x00E2;  //RW		//bit 7-0
pdata BYTE rEER_ADDRH     _at_ 0x00E3;  //RW		//bit 11-8
pdata BYTE rEER_ERASE     _at_ 0x00E4;	//W
pdata BYTE rEER_DATA0     _at_ 0x00E8;  // W

// SPI
pdata BYTE rSPI_CTL       _at_ 0x00C0;  // RW
pdata BYTE rSPI_CR1       _at_ 0x00C1;  // RW
pdata BYTE rSPI_CR2       _at_ 0x00C2;  // RW
pdata BYTE rSPI_STA       _at_ 0x00C3;  // RW
pdata BYTE rSPI_BRS       _at_ 0x00C4;  // RW

// SPI FIFO
pdata BYTE rSPI_FIFO_CLR       _at_ 0x00C8;  // W
pdata BYTE rSPI_FIFO_TX_IDX    _at_ 0x00C9;  // R
pdata BYTE rSPI_FIFO_RX_IDX    _at_ 0x00CA;  // R
pdata BYTE rSPI_FIFO_DAT       _at_ 0x00CB;  // RW
// Low Speed ADC (for key scan)
pdata BYTE rADC_CTL       _at_ 0x00D0;  // RW
pdata BYTE rADC_DATAH     _at_ 0x00D1;  // R
pdata BYTE rADC_WKVH      _at_ 0x00D2;  // RW
pdata BYTE rADC_CHN       _at_ 0x00D3;  // RW
pdata BYTE rADC_DATAL     _at_ 0x00D4;  // R
pdata BYTE rADC_WKVL      _at_ 0x00D5;  // RW
pdata BYTE rADC_TMPS      _at_ 0x00D6;  // RW
pdata BYTE rADC_VREF      _at_ 0x00D7;  // RW

// Temperature sensor
pdata BYTE rPD_TMPS       _at_ 0x00D8;  // RW

// Ananlog Comparator
pdata BYTE rPD_ACOMP      _at_ 0x00D9;  // RW 
#endif


xdata BYTE rLDO_CALIBRATION_DATA    _at_ 0x0FF9;
xdata BYTE rRC_CALIBRATION_DATA     _at_ 0x0FFB;
//=====================================================================================