#ifndef REG51F516_H                                                                         
#define REG51F516_H                                                                         
//=====================================================================================   
//--------------------------------------------------------------------------
//R8032TTE.H
//Header file for WT51F516 microcontroller.
//--------------------------------------------------------------------------
// SFR
sfr rSCON1	= 0xD8;
/*  rSCON1  */
sbit SM0_1   = rSCON1^7;
sbit SM1_1   = rSCON1^6;
sbit SM2_1   = rSCON1^5;
sbit REN_1   = rSCON1^4;
sbit TB8_1   = rSCON1^3;
sbit RB8_1   = rSCON1^2;
sbit TI_1    = rSCON1^1;
sbit RI_1    = rSCON1^0;



sfr rSBUF1	= 0xD9;
sfr rSBRG1H = 0xDA;
sfr rSBRG1L = 0xDB;

sfr rT2CON  = 0xC8;
sfr rT2MOD  = 0xC9;
sfr rRCAP2L = 0xCA;
sfr rRCAP2H = 0xCB;
sfr rTL2	= 0xCC;
sfr rTH2 	= 0xCD;

/*  rT2CON  */
sbit rTF2   = rT2CON^7;
sbit rTR2   = rT2CON^2;

sfr rSBRGH  = 0x9A;
sfr rSBRGL  = 0x9B;

sfr rAUXR	= 0x8E;
sfr rXICON	= 0xC0;

		
/*  BYTE Registers  */
sfr P0    = 0x80;
// 8051 GPIO
sbit P03   	= P0^3;
sbit P02   	= P0^2;
sbit P01    = P0^1;
sbit P00	= P0^0;

sfr P1    = 0x90;
sfr P2    = 0xA0;
sfr P3    = 0xB0;
sfr PSW   = 0xD0;
sfr ACC   = 0xE0;
sfr B     = 0xF0;
sfr SP    = 0x81;
//sfr DPL   = 0x82;
//sfr DPH   = 0x83;
sfr PCON  = 0x87;
sfr TCON  = 0x88;
sfr TMOD  = 0x89;
sfr TL0   = 0x8A;
sfr TL1   = 0x8B;
sfr TH0   = 0x8C;
sfr TH1   = 0x8D;
sfr IE    = 0xA8;
sfr IP    = 0xB8;
sfr SCON  = 0x98;
sfr SBUF  = 0x99;


sfr AUXR1	= 0x86;
sfr DPL     = 0x82;     /* Data Pointer Low Byte */
sfr DP0L    = 0x82;     /* Alternate Definition */
sfr DPH     = 0x83;     /* Data Pointer High Byte */
sfr DP0H    = 0x83;     /* Alternate Definition */
sfr DP1L    = 0x84;     /* Data Pointer 1 Low Byte */
sfr DP1H    = 0x85;     /* Data Pointer 1 High Byte */


//#define DPS_     0x04   /* Data Pointer Select: 0=DP0, 1=DP1 */
/*  80C152 Extensions  */
sfr P4    = 0xC0;
sfr P5    = 0x91;
sfr P6    = 0xA1;
sfr IEN1  = 0xC8;
sfr TSTAT = 0xD8;
sfr RSTAT = 0xE8;
sfr IPN1  = 0xF8;
sfr GMOD  = 0x84;
sfr TFIFO = 0x85;
sfr DCON0 = 0x92;
sfr DCON1 = 0x93;
sfr BAUD  = 0x94;
sfr ADR0  = 0x95;
sfr SARL0 = 0xA2;
sfr SARH0 = 0xA3;
sfr IFS   = 0xA4;
sfr ADR1  = 0xA5;
sfr SARL1 = 0xB2;
sfr SARH1 = 0xB3;
sfr SLOTTM = 0xB4;
sfr ADR2  = 0xB5;
sfr DARL0 = 0xC2;
sfr DARH0 = 0xC3;
sfr BKOFF = 0xC4;
sfr ADR3  = 0xC5;
sfr DARL1 = 0xD2;
sfr DARH1 = 0xD3;
sfr TCDCNT = 0xD4;
sfr AMSK0 = 0xD5;
sfr BCRL0 = 0xE2;
sfr BCRH0 = 0xE3;
sfr PRBS  = 0xE4;
sfr AMSK1 = 0xE5;
sfr BCRL1 = 0xF2;
sfr BCRH1 = 0xF3;
sfr RFIFO = 0xF4;
sfr MYSLOT = 0xF5;


/*  BIT Registers  */
/*  PSW  */
sbit CY    = PSW^7;
sbit AC    = PSW^6;
sbit F0    = PSW^5;
sbit RS1   = PSW^4;
sbit RS0   = PSW^3;
sbit OV    = PSW^2;
sbit P     = PSW^0; //8052 only

/*  TCON  */
sbit TF1   = TCON^7;
sbit TR1   = TCON^6;
sbit TF0   = TCON^5;
sbit TR0   = TCON^4;
sbit IE1   = TCON^3;
sbit IT1   = TCON^2;
sbit IE0   = TCON^1;
sbit IT0   = TCON^0;

/*  IE  */
sbit EA    = IE^7;
sbit ES1   = IE^6;	
sbit ET2   = IE^5; 	//8052 only
sbit ES    = IE^4;
sbit ET1   = IE^3;
sbit EX1   = IE^2;
sbit ET0   = IE^1;
sbit EX0   = IE^0;

/*  IP  */
sbit PT2   = IP^5;
sbit PS    = IP^4;
sbit PT1   = IP^3;
sbit PX1   = IP^2;
sbit PT0   = IP^1;
sbit PX0   = IP^0;

/*  P3  */
sbit RD    = P3^7;
sbit WR    = P3^6;
sbit T1    = P3^5;
sbit T0    = P3^4;
sbit INT1  = P3^3;
sbit INT0  = P3^2;
sbit TXD   = P3^1;
sbit RXD   = P3^0;

/*  SCON  */
sbit SM0   = SCON^7;
sbit SM1   = SCON^6;
sbit SM2   = SCON^5;
sbit REN   = SCON^4;
sbit TB8   = SCON^3;
sbit RB8   = SCON^2;
sbit TI    = SCON^1;
sbit RI    = SCON^0;
#define     PDATA_FOR_XFR            0

#define     XDATA_FOR_XFR            1

#define     XFR_USEING                   PDATA_FOR_XFR //         XDATA_FOR_XFR            

#if(XFR_USEING==XDATA_FOR_XFR)
// System Level Register
extern xdata BYTE rCHIP_ID		 ;  // R
extern xdata BYTE rSYS_CTL1 	 ; 	// RW
extern xdata BYTE rSYS_CTL2      ;  // RW

// Watchdog Timer 
extern xdata BYTE rWATCHDOG      ;  // RW 
extern xdata BYTE rWDT_RST       ;  // RW
extern xdata BYTE rWDT_DET       ;  // RW

// Low voltage detect
extern xdata BYTE rLVD_SEL       ;  // RW

// Calibrate VDD3.3 & VDD 1.8V
extern xdata BYTE rLDO_DATA      ;  // RW
extern xdata BYTE rPD_SEL		 ;	
// GPIO
extern xdata BYTE rGPIOA_OEN     ;  // RW
extern xdata BYTE rGPIOB_OEN     ;  // RW
extern xdata BYTE rGPIOC_OEN     ;  // RW 

extern xdata BYTE rGPIOA_DAT     ;  // RW
extern xdata BYTE rGPIOB_DAT     ;  // RW
extern xdata BYTE rGPIOC_DAT     ;  // RW 

extern xdata BYTE rGPIOA_PHN     ;  // RW
extern xdata BYTE rGPIOB_PHN     ;  // RW
extern xdata BYTE rGPIOC_PHN     ;  // RW

extern xdata BYTE rGPIOA_TPY     ;  // RW
extern xdata BYTE rGPIOB_TPY     ;  // RW
extern xdata BYTE rGPIOC_TPY     ;  // RW


extern xdata BYTE rGPIO_CTL0     ;  // RW
extern xdata BYTE rGPIO_CTL1     ;  // RW
extern xdata BYTE rGPIO_CTL2     ;  // RW
extern xdata BYTE rGPIO_CTL3     ;  // RW

//Wake-up & toggle Register
extern xdata BYTE rWK_CTL0       ;  // RW
extern xdata BYTE rWK_CTL1       ;  // RW
extern xdata BYTE rWK_CTL2       ;  // RW
extern xdata BYTE rWK_CTL3       ;  // RW
extern xdata BYTE rTOG_CTL0      ;  // R
extern xdata BYTE rTOG_CTL1      ;  // R
extern xdata BYTE rTOG_CTL2    	 ;  // R
extern xdata BYTE rTOG_CTL3      ;  // R
extern xdata BYTE rTOG_CTL4      ;  // R

// RC oscillator calibration
extern xdata BYTE rOSC_RCH	     ;  // R
extern xdata BYTE rOSC_RCL       ;  // R
extern xdata BYTE rOSC_IADJ0     ;  // RW

              

// 8051 Interrupt 1
extern xdata BYTE rINT0_CTL0     ;  // RW
extern xdata BYTE rINT0_CTL1     ;  // RW
extern xdata BYTE rINT1_CTL0     ;  // RW
extern xdata BYTE rINT1_CTL1     ;  // RW


extern xdata BYTE rINT0_FLAG0    ;  // R
extern xdata BYTE rINT0_FLAG1    ;  // R
//extern xdata BYTE rINT1_FLAG0    ;  // R
//extern xdata BYTE rINT1_FLAG1    ;  // R
extern xdata BYTE rEVT_IRQ	;
extern xdata BYTE rIRQ_CHG	;

// HV & SOG DPMS detect
extern xdata BYTE rSMP_CNT_EN	 ;  // RW
extern xdata BYTE rSMP_SCAN_TIME ;  // RW
extern xdata BYTE rSMP_EVENT	 ;  // RW
extern xdata BYTE rSMP_EVENT1	 ;  // RW
extern xdata BYTE rSMP_EVENT_CLR ;  // RW

extern xdata BYTE rSMP_THR_L     ;  // RW
extern xdata BYTE rSMP_THR_H	 ;  // RW
extern xdata BYTE rSMP_CNT_L     ;  // RW
extern xdata BYTE rSMP_CNT_H	 ;  // RW

extern xdata BYTE rSMP_I_SEL	 ;  // RW
extern xdata BYTE rSMP_RC_PL	 ;  // RW


// PWM
extern xdata BYTE rPWM_EN        ;  // RW
extern xdata BYTE rPWM_BAS       ;  // RW 
extern xdata BYTE rPWM0_CLK      ;  // RW
extern xdata BYTE rPWM1_CLK      ;  // RW 
extern xdata BYTE rPWM2_CLK      ;  // RW
extern xdata BYTE rPWM3_CLK      ;  // RW 

extern xdata BYTE rPWM0_DAL      ;  // RW
extern xdata BYTE rPWM0_DAH      ;  // RW 
extern xdata BYTE rPWM1_DAL      ;  // RW
extern xdata BYTE rPWM1_DAH      ;  // RW 
extern xdata BYTE rPWM2_DAL      ;  // RW
extern xdata BYTE rPWM2_DAH      ;  // RW 
extern xdata BYTE rPWM3_DAL      ;  // RW
extern xdata BYTE rPWM3_DAH      ;  // RW 

// Remote Control
extern xdata BYTE rIR_CTL        ;  // RW
extern xdata BYTE rIR_STA        ;  // R
extern xdata BYTE rIR_CNT        ;  // R
extern xdata BYTE rIR_FIT	     ;  // RW

// HDMI CEC Control
extern xdata BYTE rCEC_CTL0      ;  // RW
extern xdata BYTE rCEC_CTL1      ;  // RW
extern xdata BYTE rCEC_CTL2      ;  // RW
extern xdata BYTE rCEC_IF        ;  // R
extern xdata BYTE rCEC_INT_CLR   ;  // RW
extern xdata BYTE rCEC_DTX       ;  // RW
extern xdata BYTE rCEC_DRX       ;  // R

// FIFO
extern xdata BYTE rFIFO_CLR      ;  // W
extern xdata BYTE rFIFO_TX_IDX      ;  // R
extern xdata BYTE rFIFO_RX_IDX      ;  // R
extern xdata BYTE rFIFO_DAT      ;  // RW

// Master/Slave I2C Interface
extern xdata BYTE rI2C_CTL       ;  // RW
extern xdata BYTE rI2C_NUM       ;  // RW
extern xdata BYTE rI2C_CLR       ;  // RW

extern xdata BYTE rI2C_STA       ;  // R
extern xdata BYTE rI2C_SADR      ;  // RW

// RTC(Real Time Clock)
extern xdata BYTE rRTC_CTL       ;  // R.W
extern xdata BYTE rRTC_SEC       ;  // RW
extern xdata BYTE rRTC_MIN       ;  // RW
extern xdata BYTE rRTC_HOUR      ;  // RW
extern xdata BYTE rRTC_DAY       ;  // RW
extern xdata BYTE rRTC_WEEK      ;  // RW
extern xdata BYTE rRTC_MONTH     ;  // RW
extern xdata BYTE rRTC_YEAR      ;  // RW

extern xdata BYTE rRTC_BACKUP1   ;  // RW
extern xdata BYTE rRTC_BACKUP2   ;  // RW
extern xdata BYTE rRTC_BACKUP3   ;  // RW
extern xdata BYTE rRTC_BACKUP4   ;  // RW

extern xdata BYTE rRTC_CA        ;  // RW
extern xdata BYTE rRTC_OSC       ;  // RW
extern xdata BYTE rRTC_MISC      ;  // RW

// SPI
extern xdata BYTE rSPI_CTL       ;  // RW
extern xdata BYTE rSPI_CR1       ;  // RW
extern xdata BYTE rSPI_CR2       ;  // RW
extern xdata BYTE rSPI_STA       ;  // RW
extern xdata BYTE rSPI_BRS       ;  // RW
// SPI FIFO
extern xdata BYTE rSPI_FIFO_CLR       ;  // W
extern xdata BYTE rSPI_FIFO_TX_IDX    ;  // R
extern xdata BYTE rSPI_FIFO_RX_IDX    ;  // R
extern xdata BYTE rSPI_FIFO_DAT       ;  // RW
// Low Speed ADC (for key scan)
extern xdata BYTE rADC_CTL       ;  // RW
extern xdata BYTE rADC_DATAH     ;  // R
extern xdata BYTE rADC_WKVH      ;  // RW
extern xdata BYTE rADC_CHN       ;  // RW
extern xdata BYTE rADC_DATAL     ;  // R
extern xdata BYTE rADC_WKVL      ;  // RW
extern xdata BYTE rADC_TMPS      ;  // RW
extern xdata BYTE rADC_VREF      ;  // RW

// Temperature sensor
extern xdata BYTE rPD_TMPS       ;  // RW

// Ananlog Comparator
extern xdata BYTE rPD_ACOMP      ;  // RW 	





								 
extern xdata BYTE rEER_EN1       ;  // W
extern xdata BYTE rEER_EN2       ;  // W
extern xdata BYTE rEER_ADDRL     ;  //RW		//bit 7-0
extern xdata BYTE rEER_ADDRH     ;  //RW		//bit 11-8
extern xdata BYTE rEER_ERASE     ;	//W
extern xdata BYTE rEER_DATA0     ;  // W

#endif
#if(XFR_USEING==PDATA_FOR_XFR)
// System Level Register
extern pdata BYTE rCHIP_ID		 ;  // R
extern pdata BYTE rSYS_CTL1 	 ; 	// RW
extern pdata BYTE rSYS_CTL2      ;  // RW

// Watchdog Timer 
extern pdata BYTE rWATCHDOG      ;  // RW 
extern pdata BYTE rWDT_RST       ;  // RW
extern pdata BYTE rWDT_DET       ;  // RW

// Low voltage detect
extern pdata BYTE rLVD_SEL       ;  // RW

// Calibrate VDD3.3 & VDD 1.8V
extern pdata BYTE rLDO_DATA      ;  // RW
extern pdata BYTE rPD_SEL		 ;	
// GPIO
extern pdata BYTE rGPIOA_OEN     ;  // RW
extern pdata BYTE rGPIOB_OEN     ;  // RW
extern pdata BYTE rGPIOC_OEN     ;  // RW 

extern pdata BYTE rGPIOA_DAT     ;  // RW
extern pdata BYTE rGPIOB_DAT     ;  // RW
extern pdata BYTE rGPIOC_DAT     ;  // RW 

extern pdata BYTE rGPIOA_PHN     ;  // RW
extern pdata BYTE rGPIOB_PHN     ;  // RW
extern pdata BYTE rGPIOC_PHN     ;  // RW

extern pdata BYTE rGPIOA_TPY     ;  // RW
extern pdata BYTE rGPIOB_TPY     ;  // RW
extern pdata BYTE rGPIOC_TPY     ;  // RW


extern pdata BYTE rGPIO_CTL0     ;  // RW
extern pdata BYTE rGPIO_CTL1     ;  // RW
extern pdata BYTE rGPIO_CTL2     ;  // RW
extern pdata BYTE rGPIO_CTL3     ;  // RW

//Wake-up & toggle Register
extern pdata BYTE rWK_CTL0       ;  // RW
extern pdata BYTE rWK_CTL1       ;  // RW
extern pdata BYTE rWK_CTL2       ;  // RW
extern pdata BYTE rWK_CTL3       ;  // RW
extern pdata BYTE rTOG_CTL0      ;  // R
extern pdata BYTE rTOG_CTL1      ;  // R
extern pdata BYTE rTOG_CTL2    	 ;  // R
extern pdata BYTE rTOG_CTL3      ;  // R
extern pdata BYTE rTOG_CTL4      ;  // R

// RC oscillator calibration
extern pdata BYTE rOSC_RCH	     ;  // R
extern pdata BYTE rOSC_RCL       ;  // R
extern pdata BYTE rOSC_IADJ0     ;  // RW

              

// 8051 Interrupt 1
extern pdata BYTE rINT0_CTL0     ;  // RW
extern pdata BYTE rINT0_CTL1     ;  // RW
extern pdata BYTE rINT1_CTL0     ;  // RW
extern pdata BYTE rINT1_CTL1     ;  // RW


extern pdata BYTE rINT0_FLAG0    ;  // R
extern pdata BYTE rINT0_FLAG1    ;  // R
//extern pdata BYTE rINT1_FLAG0    ;  // R
//extern pdata BYTE rINT1_FLAG1    ;  // R
extern pdata BYTE rEVT_IRQ	;
extern pdata BYTE rIRQ_CHG	;
// HV & SOG DPMS detect
extern pdata BYTE rSMP_CNT_EN	 ;  // RW
extern pdata BYTE rSMP_SCAN_TIME ;  // RW
extern pdata BYTE rSMP_EVENT	 ;  // RW
extern pdata BYTE rSMP_EVENT1	 ;  // RW
extern pdata BYTE rSMP_EVENT_CLR ;  // RW

extern pdata BYTE rSMP_THR_L     ;  // RW
extern pdata BYTE rSMP_THR_H	 ;  // RW
extern pdata BYTE rSMP_CNT_L     ;  // RW
extern pdata BYTE rSMP_CNT_H	 ;  // RW

extern pdata BYTE rSMP_I_SEL	 ;  // RW
extern pdata BYTE rSMP_RC_PL	 ;  // RW


// PWM
extern pdata BYTE rPWM_EN        ;  // RW
extern pdata BYTE rPWM_BAS       ;  // RW 
extern pdata BYTE rPWM0_CLK      ;  // RW
extern pdata BYTE rPWM1_CLK      ;  // RW 
extern pdata BYTE rPWM2_CLK      ;  // RW
extern pdata BYTE rPWM3_CLK      ;  // RW 

extern pdata BYTE rPWM0_DAL      ;  // RW
extern pdata BYTE rPWM0_DAH      ;  // RW 
extern pdata BYTE rPWM1_DAL      ;  // RW
extern pdata BYTE rPWM1_DAH      ;  // RW 
extern pdata BYTE rPWM2_DAL      ;  // RW
extern pdata BYTE rPWM2_DAH      ;  // RW 
extern pdata BYTE rPWM3_DAL      ;  // RW
extern pdata BYTE rPWM3_DAH      ;  // RW 

// Remote Control
extern pdata BYTE rIR_CTL        ;  // RW
extern pdata BYTE rIR_STA        ;  // R
extern pdata BYTE rIR_CNT        ;  // R
extern pdata BYTE rIR_FIT	     ;  // RW

// HDMI CEC Control
extern pdata BYTE rCEC_CTL0      ;  // RW
extern pdata BYTE rCEC_CTL1      ;  // RW
extern pdata BYTE rCEC_CTL2      ;  // RW
extern pdata BYTE rCEC_IF        ;  // R
extern pdata BYTE rCEC_INT_CLR   ;  // RW
extern pdata BYTE rCEC_DTX       ;  // RW
extern pdata BYTE rCEC_DRX       ;  // R

// FIFO
extern pdata BYTE rFIFO_CLR      ;  // W
extern pdata BYTE rFIFO_TX_IDX      ;  // R
extern pdata BYTE rFIFO_RX_IDX      ;  // R
extern pdata BYTE rFIFO_DAT      ;  // RW

// Master/Slave I2C Interface
extern pdata BYTE rI2C_CTL       ;  // RW
extern pdata BYTE rI2C_NUM       ;  // RW
extern pdata BYTE rI2C_CLR       ;  // RW

extern pdata BYTE rI2C_STA       ;  // R
extern pdata BYTE rI2C_SADR      ;  // RW

// RTC(Real Time Clock)
extern pdata BYTE rRTC_CTL       ;  // R.W
extern pdata BYTE rRTC_SEC       ;  // RW
extern pdata BYTE rRTC_MIN       ;  // RW
extern pdata BYTE rRTC_HOUR      ;  // RW
extern pdata BYTE rRTC_DAY       ;  // RW
extern pdata BYTE rRTC_WEEK      ;  // RW
extern pdata BYTE rRTC_MONTH     ;  // RW
extern pdata BYTE rRTC_YEAR      ;  // RW

extern pdata BYTE rRTC_BACKUP1   ;  // RW
extern pdata BYTE rRTC_BACKUP2   ;  // RW
extern pdata BYTE rRTC_BACKUP3   ;  // RW
extern pdata BYTE rRTC_BACKUP4   ;  // RW

extern pdata BYTE rRTC_CA        ;  // RW
extern pdata BYTE rRTC_OSC       ;  // RW
extern pdata BYTE rRTC_MISC      ;  // RW

// SPI
extern pdata BYTE rSPI_CTL       ;  // RW
extern pdata BYTE rSPI_CR1       ;  // RW
extern pdata BYTE rSPI_CR2       ;  // RW
extern pdata BYTE rSPI_STA       ;  // RW
extern pdata BYTE rSPI_BRS       ;  // RW
// SPI FIFO
extern pdata BYTE rSPI_FIFO_CLR       ;  // W
extern pdata BYTE rSPI_FIFO_TX_IDX    ;  // R
extern pdata BYTE rSPI_FIFO_RX_IDX    ;  // R
extern pdata BYTE rSPI_FIFO_DAT       ;  // RW
// Low Speed ADC (for key scan)
extern pdata BYTE rADC_CTL       ;  // RW
extern pdata BYTE rADC_DATAH     ;  // R
extern pdata BYTE rADC_WKVH      ;  // RW
extern pdata BYTE rADC_CHN       ;  // RW
extern pdata BYTE rADC_DATAL     ;  // R
extern pdata BYTE rADC_WKVL      ;  // RW
extern pdata BYTE rADC_TMPS      ;  // RW
extern pdata BYTE rADC_VREF      ;  // RW

// Temperature sensor
extern pdata BYTE rPD_TMPS       ;  // RW

// Ananlog Comparator
extern pdata BYTE rPD_ACOMP      ;  // RW 	





								 
extern pdata BYTE rEER_EN1       ;  // W
extern pdata BYTE rEER_EN2       ;  // W
extern pdata BYTE rEER_ADDRL     ;  //RW		//bit 7-0
extern pdata BYTE rEER_ADDRH     ;  //RW		//bit 11-8
extern pdata BYTE rEER_ERASE     ;	//W
extern pdata BYTE rEER_DATA0     ;  // W
#endif
extern xdata BYTE rLDO_CALIBRATION_DATA   ;
extern xdata BYTE rRC_CALIBRATION_DATA 	  ;	
//=====================================================================================
#endif

