//=====================================================================================
#include "gheader.h"
//=====================================================================================

// Initial WT51F516

void SYS_InitialPort(void)
{
	 // Port A/B/C
	 // OE - 0:input  	1:output
	 // W - 0:Low 1:High
	 // R - 0:Low 1:High
 	
		// Port A bit7: IN 	(PA7/AREF)
		// Port A bit6: IN (PA6)

		// Port A bit5: IN  (PA5/MOSI) 
		// Port A bit4: OUT  (LED4/PWM3)
		// Port A bit3: OUT (LED3)
		// Port A bit2: IN	(CEC)
		// Port A bit1: IN	(IR)
		// Port A bit0: OUT	(LED2/PWM1)
		rGPIOA_DAT = 0x00;					
		rGPIOA_OEN = 0x19;  //00011001
		

		// Port B bit0: IN	(PB0_ADC)
		// Port B bit1: IN	(PB1_ADC)
		// Port B bit2: IN 	(T3) 
		// Port B bit3: IN 	(T4)
		// Port B bit4: IN 	(T5)
		// Port B bit5: IN	(T6)
		// Port B bit6: IN	(T7/KEY1)
		// Port B bit7: IN	(T8?KEY2)
		rGPIOB_DAT = 0xFF;
		rGPIOB_OEN = 0x00;		
		//rGPIOB_PHN =0xFF;


		// Port C bit0: IN		(NC)
		// Port C bit1: IN 		(PC1)
		// Port C bit2: OUT		(PC2) control main chip power
		// Port C bit3: IN		(PC3_RXD)
		// Port C bit4: IN  	(PC4_TXD)
		// Port C bit5: OUT 	(PC5_LED/PWM0)
		// Port C bit6: IN		(PC6_RXD1)
		// Port C bit7: IN		(PC7_TXD1)		
			rGPIOC_DAT = 0x00; 
			rGPIOC_OEN = 0x26;  //00100100  	
			
			

}

//=====================================================================================
//
//=====================================================================================                                                                                   
void SYS_DelayMs(WORD  ms)		                                                  
{                                                                                         
  WORD i, j;                                                                             
                                                                                          
  for(i = 0; i < ms; i++)                                                                 
  {                                                                                       
    
		//for(j = 0; j < 0x8C; j++)	//For WT61P7 11.0592MHZ 
		for(j = 0; j < 0x96; j++)	//For WT61P7 12MHZ                         
    {                                                                                     
      _nop_();  			//0.25uS                                                                          
      _nop_();                                                                            
      _nop_();                                                                            
      _nop_();                                                                            
      _nop_();                                                                            
			_nop_();                                                          
      _nop_();                                                                            
			_nop_();                                                          
      _nop_();                                                                            
			_nop_();                                                          
      _nop_();                                                                            
			_nop_();                                                          
      _nop_(); 						//For WT61P7 12MHZ			                                                                         
    }                                                                                     
  }                                                                                       
}        


