//=====================================================================================
#include "gheader.h"
//=====================================================================================
//
//=====================================================================================
#define		IF_LVD		0x20
#define		IF_WDTC		0x10

#define		IF_CTOUCH	0x04		
#define		IF_SPI		0x02
#define		IF_SIIC		0x01

#define		IF_ALLIN	0x10
#define		IF_RTC1S	0x08
#define		IF_KADC		0x04
#define		IF_IR		0x02
#define		IF_CEC		0x01
//---------------------------------------------------------
//				Interrupt  Function
// Interrupt Number Interrupt Description Address



//External Interrupt  0	       03H	0   (highest)	IE.0	TCON.0
//Timer/Counter       0	       0BH	1	  IE.1	--
//External Interrrupt 1	       13H	2	  IE.2	TCON.2
//Timer/Counter1	           1BH	3	  IE.3	--
//Serial Port	               23H	4	  IE.4	--
//Timer/Counter2	            2BH	5	  IE.5 	--
//Serial Port 1	               33H	6 	  IE.6	--
//External Interrupt 2	       3BH	7	  XICON.2	XICON.0
//External Interrupt 3	       43H	8  (lowest)	XICON.6	XICON.4

//---------------------------------------------------------

void INT0_ISR_Entry(void) interrupt 0 
{	

	#if INT0_SELF_TEST  	
	fSystemInt0Event = 1;
	INT0Data0 = rINT0_FLAG0;
	INT0Data1 = rINT0_FLAG1;	
	#endif


	#ifdef ENABLE_I2C_MODE
	if(rINT0_FLAG0 & IF_SIIC)
  	{   		  	
    	ISR_HwI2c(); 				
  	}
	 #endif	

	
	#ifdef ENABLE_CTOUCH_MODE 
    if(rINT0_FLAG0 & IF_CTOUCH)
  	{
  		Get_RawData(); 
	}
	#endif
//-------------------------------------	
	#if(IR_TARGET==ACTIVE_INT0)
	if(rINT0_FLAG1 & IF_IR)
  	{
  		HW_IR_ISR()  
		
	}	
	#endif
//--------------------------------------
	if(rINT0_FLAG1 & IF_RTC1S)
  	{	
  	
		gsbSecFlag = 1;
		rRTC_CTL = 0x01;			  //clear RTC 1sec interrupt 	
  	}
//--------------------------------------
	#if VDD_SELF_TEST
	if(rINT0_FLAG0 & IF_LVD)
  	{	
  	
		fSystemVddInt0Event = 1;
		rLVD_SEL |= 0x80; ;			  //clear LVD interrupt 	
  	}
	#endif
//--------------------------------------
	#if DWDT_SELF_TEST
	if(rINT0_FLAG0 & IF_WDTC)
  	{	
  		
		fSystemWdtInt0Event = 1;
		rWDT_DET = 0x02;
		rWATCHDOG |= 0x80;  		// Disable Watchdog Timer
 		rWATCHDOG &= 0x7F;			// Enable Watchdog Timer
		
	
  	}
	#endif

}
//======================================================
//
//======================================================
void INT1_ISR_Entry(void) interrupt 2 
{ 


}
//======================================================
//
//======================================================
void INT2_ISR_Entry(void) interrupt 7 
{ 


}
//======================================================
//
//======================================================
void INT3_ISR_Entry(void) interrupt 8 
{
#ifdef ENABLE_I2C_MODE 
//ISR_HwI2c(); 
#endif 
}