#ifndef INTERRUPT_H
#define INTERRUPT_H
//=====================================================================================


#define INT0_CTL_LVD_EN          DefineBit(rINT0_CTL0, bit5)     //LVD interrupt enable
#define INT0_CTL_WDT_EN          DefineBit(rINT0_CTL0, bit4)     //WDT interrupt enable

#define INT0_CTL_CTOUCH_EN       DefineBit(rINT0_CTL0, bit2)     //CTOUCH interrupt enable
#define INT0_CTL_SPI_EN          DefineBit(rINT0_CTL0, bit1)     //SPI interrupt enable
#define INT0_CTL_SIIC_EN         DefineBit(rINT0_CTL0, bit0)     //SIIC interrupt enable

#define INT0_CTL_AllIN_EN       DefineBit(rINT0_CTL1, bit4)     //All-input interrupt enable
#define INT0_CTL_1SEC_EN        DefineBit(rINT0_CTL1, bit3)     //RTC 1sec interrupt enable
#define INT0_CTL_ADC_EN        	DefineBit(rINT0_CTL1, bit2)     //ADC interrupt enable
#define INT0_CTL_IR_EN			DefineBit(rINT0_CTL1, bit1)     //IR interrupt enable
#define INT0_CTL_CEC_EN     	DefineBit(rINT0_CTL1, bit0)     //CEC interrupt enable
//========================================================================================			 
#define INT1_CTL_ALLIN_EN          DefineBit(rINT1_CTL0, bit6)     //LVD interrupt enable
#define INT1_CTL_LVD_EN          DefineBit(rINT1_CTL0, bit5)     //LVD interrupt enable
#define INT1_CTL_WDT_EN          DefineBit(rINT1_CTL0, bit4)     //WDT interrupt enable

#define INT1_CTL_CTOUCH_EN       DefineBit(rINT1_CTL0, bit2)     //CTOUCH interrupt enable
#define INT1_CTL_SPI_EN          DefineBit(rINT1_CTL0, bit1)     //SPI interrupt enable
#define INT1_CTL_SIIC_EN         DefineBit(rINT1_CTL0, bit0)     //SIIC interrupt enable

#define INT1_CTL_IRQ0_EN       DefineBit(rINT1_CTL1, bit4)     //All-input interrupt enable
#define INT1_CTL_1SEC_EN        DefineBit(rINT1_CTL1, bit3)     //RTC 1sec interrupt enable
#define INT1_CTL_ADC_EN        	DefineBit(rINT1_CTL1, bit2)     //ADC interrupt enable
#define INT1_CTL_IR_EN			DefineBit(rINT1_CTL1, bit1)     //IR interrupt enable
#define INT1_CTL_CEC_EN     	DefineBit(rINT1_CTL1, bit0)     //CEC interrupt enable




#define INT_STA_HV               DefineBit(rINT0_FLAG0, bit5)    //HV detect interrupt flag
#define INT_STA_HWIR             DefineBit(rINT0_FLAG0, bit3)    //H/W IR interrupt flag




//=====================================================================================
#endif