//=====================================================================================
#include "gheader.h"

//=====================================================================================
BYTE idata PMCTL_DATA[PMCTL_DATA_SIZE];

BYTE idata gbSystemVersion;
BYTE idata gbSystemPowerDownCommand;
BYTE idata gbSystemWakeupState;
BYTE idata gbSystemPowerDownState;
bdata bit IR_EN_FLAG;

BYTE idata gbSystemWdtState;
bit gfGetRawDataFinish;

idata BYTE gbTestData;
BYTE idata SystemClock;
//=====================================================================================
//
//=====================================================================================
BYTE data CheckCodeStatus;

#define CHECK_OK	0x01
#define CHECK_FAIL	0x02
//=====================================================================================
//
//=====================================================================================
void main(void) using 0
//void main_app(void)	using 0
{
	CheckCodeStatus = rGPIOB_TPY;	
	//CheckCodeStatus = CHECK_OK;
	gbSystemWdtState = rWATCHDOG;   //backup watchdog event	
	//========RC calibratin function=========
	SYS_LoadCalibrationData(); 
	//===============================
	rSYS_CTL2 |= 0x20;				//Reduce flash power by timing share
	rSYS_CTL1 &=~0x80;				//Enable reset have digital filter
	rSYS_CTL1 |= 0x02;	  			//32K oscillator enable

	rWATCHDOG |=0xC0;				//Disable watch dog & WDT clock source from MCU clock	
	rWDT_RST = WD_RST_TIME_2S;	   	//Set Watch dog count 2sec reset
	rWDT_DET = WD_DET_TIME_5S;		//Set Watch dig Detect time is 5sec

	DelayWhile(2000);

 	SYS_InitialPort();				//Set WT51F516 GPIO In/Output					  
	DRV_InitPowerOn();			    //Set WT51F516 Special function initial

	rWATCHDOG |=0xC0;				//Disable watch dog & WDT clock source from MCU clock
	rWDT_RST = WD_RST_TIME_2S;	   	//Set Watch dog count 2sec reset
	rWDT_DET = WD_DET_TIME_5S;		//Set Watch dig Detect time is 5sec

	#if 1	
	if(CheckCodeStatus==CHECK_OK)
	{
		
		DRV_PutStr("WT51F516 Check Customer Code is OK! \r\n");
	}
	else
	{
		DRV_PutStr("WT51F516 Check Customer Code is Fail! \r\n");
	}
	#endif 
//================Power On Test================//
	DRV_PutStr("WT51F516 Load 1.8V OK \r\n");
	DRV_PutStr("WT51F516 Load Rosc 12MHZ OK \r\n");
	DRV_PutStr("WT51F516 Set GPIO OK \r\n");
	DRV_Printf("Last rWATCHDOG = %x \r\n",gbSystemWdtState);
	DRV_Printf("WT51F516 Firmware Version = %x \r\n",FIRMWARE_VERSION);	
//==========================================//		
	

	EA = 1;
	//Using Embedded ICE, do not set IP
	//Support 4 point breakpoints
//=============for ICE  debug use======	
	if(WT51F516EmbededICE==Enable)
	{
		IP = 0;
	}
//===============================
//Main Loop

	
	while(1)
	{
	//Check Polling Flag
	//========Timer Count ===============
	Timer0Service();	
	//===============================
	//========RC calibratin function==========
	if(fRoscTimerEvent == 1)		//200ms
	{
		fRoscTimerEvent = 0; 		
		SYS_RoscCalibration(0x0A);
	}
	//===============================
	//===========ADC Key function routine=======
	//ADC0 & ADC1
	#ifdef ENABLE_APIAKEY_MODE
	if(fAkeypadTimeEvent == 1)		//20ms
	{
		//Polling Analogkeypad
		DRV_CheckAnalogKeyRoutine();
		fAkeypadTimeEvent = 0;
	}	
	#endif
	//===============================
	//========key function===============	
#ifdef ENABLE_APIDKEY_MODE	
	if(fKeypadTimeEvent == 1)		//20ms
	{
		//Polling keypad
		DRV_DigitalKeyPadRoutine();
		DRV_DigitalKey2Routine();
		fKeypadTimeEvent = 0;
	}
#endif
	//===================================
	//Polling IR 
	//========IR function===============	
	if(fIrTimerEvent == 1)
	{
		IR_routine();
		fIrTimerEvent = 0;
	}
	//==============================	

	//==========RTC function===========
#ifdef ENABLE_RTC_MODE
	//RTC
	if(fAlarmTimer == 1)
	{
		//Check RTC updated
		API_UpdateRtc();
		//Check Alarm1
		API_WakeUpAlarmRoutine();
		//Check Alarm2
		API_PowerDownAlarmRoutine();
		fAlarmTimer = 0;

#if 0
		//DRV_Printf("gbRtcHour = %d ",gbRtcHour);
		//DRV_Printf("gbRtcMin = %d ",gbRtcMin);
		DRV_Printf("gbRtcSec = %d \r\n",gbRtcSec);		
#endif
#if 0
		DRV_Printf("gbRtcYear = %d ",gbRtcYear);

		DRV_Printf("gbRtcMonth = %d ",gbRtcMonth);
		DRV_Printf("gbRtcDay = %d ",gbRtcDay);	
		DRV_Printf("gbRtcWeek = %d \r\n",gbRtcWeek);	
#endif
	}
#endif	
//=================================
	
	//===========On/Off IR function========
	// Check IR enable or disable command
	if(IR_EN_FLAG)
	{
		IR_EN_FLAG = 0;
		if(PowerStatus == PWR_ON)
		{
			IR_PWR_DOWN_EN_CHK();
		}
		else
		{
			IR_WAKE_UP_EN_CHK();
		}
	}
	//===============================	
 


	//Selfetest
	//============for RTC 1S =============
	if(gsbSecFlag==1)
	{
		gsbSecFlag = 0;		
		DRV_Printf("RTC %dsec interrupt \r\n ",1);
			
	}
	//================================
	//Reset Watchdog
    	OS_Reset_WD();
	}		//main while loop

	
}	//main 




//=====================================================================================
//=====================================================================================
void DRV_InitPowerOn(void)
{

	BYTE  *subaddr_ptr, idx;

	//Init Registers 
  	//OS Init
  	//Setup Sub Address default value
	*SubAddr_Table[0x00] = FIRMWARE_VERSION;
	*SubAddr_Table[0x01] = HOST_CMD_NULL;
	*SubAddr_Table[0x02] = HOST_WAKEUP_VIA_DC;

  	idx = 0x10;
 	subaddr_ptr = SubAddr_Table[idx];
  	while(subaddr_ptr != End_of_SubAddr_Table)
  	{
  		*subaddr_ptr = SubAddr_Default_Table[idx];
  		subaddr_ptr = SubAddr_Table[++idx];
  	}


	rINT0_CTL0 = 0x00;
	rINT0_CTL1 = 0x00;
	rINT1_CTL0 = 0x00;	
	rINT1_CTL1 = 0x00;
	//System Timer Base
    OS_TimerInitial();			//Set Timer0 10ms


	//Init Watchdog
	#if(ACTIVE_WD_TIMER == ON)
  	OS_WD_FUN_DIS = 0;
  	OS_Reset_WD();
	#else
  	OS_WD_FUN_DIS = 1;
	#endif

	#ifdef ENABLE_UARTDEBUG_MODE
	API_UartDebugInitial();  	
	#endif
	

	
	#ifdef ENABLE_I2C_MODE 
	DRV_I2cInitial();
	#endif

	#ifdef ENABLE_RTC_MODE 
	DRV_RtcInitial();  					// ok
	DRV_Rtc1SecInitial();  			// ok
	#endif
	DRV_IrInitial();						// ok
 
	 

	#ifdef ENABLE_APIDKEY_MODE
	DRV_DigitalKeyInitial();	// ok
	#endif	

	#ifdef ENABLE_APIAKEY_MODE
	API_AnalogKeyInitial();
	#endif
	DRV_PwmInitial();		  	// ok only 47KHZ	
	
	#ifdef _ENABLE_ADC_TOUCH_
	DRV_InitialTouchKey();
	#endif
}



//=====================================================================================
//
//=====================================================================================
void SYS_LoadCalibrationData(void)
{
	//RC Debug
	//rPD_SEL |= 0x04;	//Output RC oscillator to GPIOC5/PWM0
	//rPD_SEL |= 0x01;	//Output crystal oscillator 32.768KHZ to GPIOC5

	if(rLDO_CALIBRATION_DATA & 0x80)
	{
	 	rLDO_DATA = LDO_DEFAULT_18V;
	}
	else
	{
		rLDO_DATA = rLDO_CALIBRATION_DATA;
	}

	// 53  *20% 10.6  Range 74 ~ 42
	//default information block data is 0xFF
	if(rRC_CALIBRATION_DATA & 0x80)
	//if(rRC_CALIBRATION_DATA> 74 || rRC_CALIBRATION_DATA < 42)
	//if(rRC_CALIBRATION_DATA> 0x90 || rRC_CALIBRATION_DATA < 0x40)
	{
	   rOSC_IADJ0 = ROSC_DEFAULT_12MHZ;
	}
	else
	{
		rOSC_IADJ0 = rRC_CALIBRATION_DATA;
	}

}


//=====================================================================================
//
//=====================================================================================
void SYS_RoscCalibration(BYTE retry_cnt)
{
	
	#if(EXTERNAL_32K == ON)


	#define	SORTING_SIZE	0x03

	WORD RoscCounter[SORTING_SIZE];
	BYTE R6,R7;	
	WORD ROscStableCounter;	
	BYTE RoscFineCounter;
	
	#if 0
	DRV_PutStr("Run SYS_RoscCalibration Routine\r\n");
	#endif
	while(retry_cnt != 0)
    {
    	retry_cnt--;	
//--------------------------------------------------
		for(R7=0;R7<SORTING_SIZE;R7++)
		{		
			RoscCounter[R7] = rOSC_RCH * 4;
			RoscCounter[R7] = RoscCounter[R7] + (rOSC_RCL & 0x03);
		}
		//Sorting
		for(R6=0;R6<SORTING_SIZE;R6++)
		{
			for(R7=0;R7<3;R7++)
			{
				if(RoscCounter[R7] > RoscCounter[R7+1])
				{
					ROscStableCounter = RoscCounter[R7+1];
			  		RoscCounter[R7+1] = RoscCounter[R7];
					RoscCounter[R7]= ROscStableCounter;
				}
			}
		}
//--------------------------------------------------
		#if 0		
		DRV_Printf("  RoscCounter[0] = %d",RoscCounter[0]);
		DRV_Printf("  RoscCounter[1] = %d",RoscCounter[1]);
		DRV_Printf("  RoscCounter[2] = %d\r\n",RoscCounter[2]);		
		#endif
		
		//stable data
		ROscStableCounter = RoscCounter[1];
		//check 32.768 OSC STOP
		if(ROscStableCounter > 1000)						//Check have 32.768KHz ??
		{
			#if 0
			DRV_PutStr("Error RC\r\n");
			#endif
		 	SYS_LoadCalibrationData();		//not have 32.768KHz,setting default value
			break;	
		}
	
//--------------------------------------------------		 	
		#if 0	
		DRV_Printf("retry_cnt = %d\r\n",retry_cnt);
		DRV_Printf("REF_OSC_CAL_VALUE = %d\r\n",REF_OSC_CAL_VALUE);		
		#endif
	
		//check range		
		if(abs(ROscStableCounter - REF_OSC_CAL_VALUE) <= OSC_CAL_RANGE)
			
    	{
			#if 0
			DRV_PutStr("Stable RC\r\n");
			DRV_Printf("RoscFineCounter = %d\r\n",ROscStableCounter);		
			#endif
			break;
        }

		#if 0
		DRV_Printf("RoscFineCounter = %d\r\n",ROscStableCounter);		
		#endif

		//Check over
		RoscFineCounter =  rOSC_IADJ0 & 0x7F;
		if(RoscFineCounter==0x00)
		{
			#if 0
			DRV_Printf("Over = %d\r\n",ROscStableCounter);		
			#endif
			SYS_LoadCalibrationData();		//ERROR, Reload default value
		 	break;
		}
		#if 0
		DRV_Printf("Start Adjust = %d\r\n",ROscStableCounter);		
		#endif	
		 //Adjust OSC_IADJ
		if(ROscStableCounter > REF_OSC_CAL_VALUE)		
    	{
			RoscFineCounter = RoscFineCounter - 1;
			rOSC_IADJ0 = RoscFineCounter;
			#if 0
			DRV_Printf("ROSC-- RoscFineCounter = %d\r\n",RoscFineCounter);			
			DRV_Printf("rOSC_IADJ0 = %d\r\n",rOSC_IADJ0);			
			#endif
		}
		else
		{
		 	RoscFineCounter = RoscFineCounter + 1;
			rOSC_IADJ0 = RoscFineCounter;
			#if 0
			DRV_Printf("ROSC++ RoscFineCounter = %d\r\n",RoscFineCounter);		
			DRV_Printf("rOSC_IADJ0 = %d\r\n",rOSC_IADJ0);			
			#endif
		} 	
	}	//while loop
	#elif(EXTERNAL_32K == OFF)
		retry_cnt--;
		SYS_LoadCalibrationData();
	#endif  

}
//=====================================================================================
//

void DRV_IntoPwrSaveMode(void)
{
	rPD_SEL|=0x80;
	//API_CheckCecBusy();		// Wait CEC Transmit finish
//DRV_PutStr("MCU into Power Saving Mode  \r\n");
	rSYS_CTL1 |= 0x80;	// Set RST_NDFILT=1
	rWATCHDOG |= 0x80;	// Disable watch dog	timer reset

	//--------------------------------  Select wake up source
	rWK_CTL0 = 0x10;	// MCU wake up by bit0:IR, bit7:I2C 
//	rWK_CTL0 = 0x01;	// MCU wake up by bit0:IR, bit7:I2C 
	rWK_CTL1 = 0x00;	// MCU wake up by GPIO_A0 port toggle (Power Key)
	rWK_CTL2 = 0x00;	// MCU wake up by GPIO_B6 port toggle (RCS)
	rWK_CTL3 = 0x00;	// MCU wake up by GPIO C3 port toggle (UART_RXD)	
	//--------------------------------

	rTOG_CTL4 |= 0x80; 	// Clear all interrupt toggle

	//------------------------------// MCU work after 4 RC clock	
	//rSYS_CTL1 |= 0x10;	//Set CLK_OFF =1
	//rSYS_CTL1 &= ~0x10;	//Set CLK_OFF =0
	//------------------------------//	

	//------------------------------// MCU work after 256 RC clock	
	//rSYS_CTL1 |= 0x40;	//Set OSC_OFF =1
	//rSYS_CTL1 &= ~0x40;	//Set OSC_OFF =0
	//------------------------------//	

	//------------------------------// MCU power save mode
	rSYS_CTL1 |= 0x01;	//Set PWR_SAVE =1
	rSYS_CTL1 &= ~0x01;	//Set PWR_SAVE =0
	//------------------------------//	

	//into sleep, then check toggle to wake up
	_nop_();                                                                            
	_nop_();                                                                            
	_nop_();                                                                            
	_nop_();                                                                            
	_nop_();                                                                            
	_nop_(); 


	rTOG_CTL4 |= 0x80; 			//Clear all interrupt toggle
	rSYS_CTL1 &= ~0x80;			//Enable reset have digital filter

	rWK_CTL0=0x00;				//Disbale  Wake up source
	rWK_CTL1=0x00;				//Disbale  Wake up source
	rWK_CTL2=0x00;				//Disbale  Wake up source
	rWK_CTL3=0x00;				//Disbale  Wake up source

	rWATCHDOG &= ~0x80;			//Enable Watch Dog 
	rWDT_RST = WD_RST_TIME_2S;  //Set Watch Dog reset time = 2 sec
//DelayWhile(500);
DRV_PutStr("MCU Wake Up  \r\n");
DelayWhile(500);
//ir_actived = OFF;	//for ir wakeup
//ir_pwr_time = 0; //for ir wakeup
//gbNextTimeIntoSleepModeCnt=10;// next 10ms go to sleep
	
}
//=====================================================================================
void System_Power_ON(BYTE stat)
{
	//Check function enable?
  	switch(stat)
  	{
    	case HOST_WAKEUP_VIA_DKEY:
      		if(!dpwr_key_wakeup_en) return;
      		break;

    	case HOST_WAKEUP_VIA_AKEY:
			if(!apwr_key_wakeup_en) return;
		    break;
		
		case HOST_WAKEUP_VIA_IR:
			if(!ir_wakeup_en) return;
		    break;			  		

		case HOST_WAKEUP_VIA_HV:
			if(!wdt_key_wakeup_en) return;
		    break;			  		

		case HOST_WAKEUP_VIA_ALARM:
			if(!alarm1_wakeup_en) return;
	        break;
		
	    case HOST_WAKEUP_VIA_DC:
	    default:
	      	break;
	}
  	gbSystemWakeupState = stat;
		if(PowerStatus == PWR_OFF)
    {
				PowerStatus = PWR_ON;
				POWER_PIN = PWR_ON;
    		IR_PWR_DOWN_EN_CHK();

			

			
	
		}
}
//=====================================================================================
//
//=====================================================================================
void System_Power_OFF(BYTE stat)
{
	//Check function enable?
  	switch(stat)
  	{
	    case HOST_PWRDOWN_VIA_I2C:
	      	if(!i2c_pwrdown_en) return;
	      	break;

	    case HOST_PWRDOWN_VIA_DKEY:
	      	if(!dpwr_key_pwrdown_en) return;
	      	break;

	    case HOST_PWRDOWN_VIA_AKEY:
	      	if(!apwr_key_pwrdown_en) return;
	      	break;

	    case HOST_PWRDOWN_VIA_IR:
	      	if(!ir_pwrdown_en) return;
	      	break;
	
	    case HOST_PWRDOWN_VIA_ALARM:
	      	if(!alarm2_pwrdown_en) return;
	      	break;

	    default:
	      	break;
  	}
  	gbSystemPowerDownState = stat;
  	if(PowerStatus == PWR_ON)
  	{
				PowerStatus = PWR_OFF;
				POWER_PIN = PWR_OFF;
    			IR_WAKE_UP_EN_CHK();
			//============power saving mode==========//
				//DRV_IntoPwrSaveMode(); 

			
				
	}
}
//=====================================================================================
//12MHZ/3=0.25uS
//
//=====================================================================================                                                                                   
void DelayWhile(WORD  ms)		                                                  
{                                                                                         
  WORD i, j;                                                                             
                                                                                          
  for(i = 0; i < ms; i++)                                                                 
  {                                                                                       
    
	//for(j = 0; j < 0x8C; j++)	
	for(j = 0; j < 0x96; j++)	                        
    {                                                                                     
      	_nop_();  			//0.25uS                                                                          
      	_nop_();                                                                            
      	_nop_();                                                                            
      	_nop_();                                                                            
      	_nop_();                                                                            
		_nop_();                                                          
      	_nop_();                                                                            
		_nop_();                                                          
      	_nop_();                                                                            
		_nop_();                                                          
      	_nop_();                                                                            
		_nop_();                                                          
     	_nop_(); 									                                                                         
    }                                                                                     
  }                                                                                       
}          



                                                                                 
//=====================================================================================   
//=====================================================================================   
//=====================================================================================
//=====================================================================================
code BYTE  *SubAddr_Table[] =
{
  	& gbSystemVersion,                              //SubAddress 0x00
  	& gbSystemPowerDownCommand,            			//SubAddress 0x01
  	& gbSystemWakeupState,                          //SubAddress 0x02
 	& gbSystemPowerDownState,                       //SubAddress 0x03
	//GPIO IN/OUT
  	& rGPIOA_OEN,                                   //SubAddress 0x04
  	& rGPIOB_OEN,                                   //SubAddress 0x05
  	& rGPIOC_OEN,                                   //SubAddress 0x06
	//GPIO DATA
	& rGPIOA_DAT,                                   //SubAddress 0x07
  	& rGPIOB_DAT,                                   //SubAddress 0x08
  	& rGPIOC_DAT,                                   //SubAddress 0x09
	//GPIO pull high for input pin
	& rGPIOA_PHN,                                   //SubAddress 0x0A
	& rGPIOB_PHN,                                   //SubAddress 0x0B
	& rGPIOC_PHN,                                   //SubAddress 0x0C
	//GPIO pull high for output pin
	& rGPIOA_TPY,									//SubAddress 0x0D
 	& rGPIOB_TPY,									//SubAddress 0x0E
	& rGPIOC_TPY,									//SubAddress 0x0F

	& PMCTL_DATA[PMCTL_DATA_CTL_DAT0_NO],			//SubAddress 0x10
    & PMCTL_DATA[PMCTL_DATA_CTL_DAT1_NO],			//SubAddress 0x11
    & PMCTL_DATA[PMCTL_DATA_CTL_DAT2_NO],			//SubAddress 0x12
    & PMCTL_DATA[PMCTL_DATA_CTL_DAT3_NO],			//SubAddress 0x13
  
    & PMCTL_DATA[PMCTL_DATA_WAKEUP_EN1_NO],			//SubAddress 0x14 
    & PMCTL_DATA[PMCTL_DATA_PWRDOWN_EN1_NO],		//SubAddress 0x15
    //ADC			
    & PMCTL_DATA[PMCTL_DATA_ADC_EN_NO],				//SubAddress 0x16
    & PMCTL_DATA[PMCTL_DATA_ADC_DATA0H_NO],			//SubAddress 0x17
    & PMCTL_DATA[PMCTL_DATA_ADC_DATA0L_NO],			//SubAddress 0x18
    & PMCTL_DATA[PMCTL_DATA_ADC_DATA1H_NO],			//SubAddress 0x19
    & PMCTL_DATA[PMCTL_DATA_ADC_DATA1L_NO],			//SubAddress 0x1A
	// ADC TEMP
    & PMCTL_DATA[PMCTL_DATA_SENSOR_DATAH_NO],		//SubAddress 0x1B
    & PMCTL_DATA[PMCTL_DATA_SENSOR_DATAL_NO],		//SubAddress 0x1C

  	//PWM only PWM0 & PWM1
	& PMCTL_DATA[PMCTL_DATA_PWM_EN_NO],				//SubAddress 0x1D
	& rPWM_EN,										//SubAddress 0x1E
	& rPWM_BAS,										//SubAddress 0x1F
	& rPWM3_CLK,									//SubAddress 0x20
	& rPWM1_CLK,										//SubAddress 0x21

	& rPWM3_DAH,								 	//SubAddress 0x22
	& rPWM3_DAL,									//SubAddress 0x23
	& rPWM1_DAH,									//SubAddress 0x24
	& rPWM1_DAL,								    //SubAddress 0x25

	// IR
  	& PMCTL_DATA[PMCTL_DATA_IR_FORMAT_NO],			//SubAddress 0x26
  	& PMCTL_DATA[PMCTL_DATA_IR_CODE0_NO],			//SubAddress 0x27
  	& PMCTL_DATA[PMCTL_DATA_IR_CODE1_NO],			//SubAddress 0x28
  	& PMCTL_DATA[PMCTL_DATA_IR_CODE2_NO],			//SubAddress 0x29
  	& PMCTL_DATA[PMCTL_DATA_IR_CODE3_NO],			//SubAddress 0x2A

  
  	& gbRtcSec,										//SubAddress 0x2B
  	& gbRtcMin,										//SubAddress 0x2C
  	& gbRtcHour,									//SubAddress 0x2D
  	& gbRtcDay,										//SubAddress 0x2E
  	& gbRtcWeek,									//SubAddress 0x2F
  	& gbRtcMonth,									//SubAddress 0x30
  	& gbRtcYear,									//SubAddress 0x31

  	& PMCTL_DATA[PMCTL_DATA_ALARM1_SEC_NO],			//SubAddress 0x32
  	& PMCTL_DATA[PMCTL_DATA_ALARM1_MIN_NO],			//SubAddress 0x33
  	& PMCTL_DATA[PMCTL_DATA_ALARM1_HOUR_NO],		//SubAddress 0x34
  	& PMCTL_DATA[PMCTL_DATA_ALARM1_DAY_NO],			//SubAddress 0x35
  	& PMCTL_DATA[PMCTL_DATA_ALARM1_MONTH_NO],		//SubAddress 0x36
  	& PMCTL_DATA[PMCTL_DATA_ALARM1_YEAR_NO],		//SubAddress 0x37

  	& PMCTL_DATA[PMCTL_DATA_ALARM2_SEC_NO],			//SubAddress 0x38
  	& PMCTL_DATA[PMCTL_DATA_ALARM2_MIN_NO],			//SubAddress 0x39
  	& PMCTL_DATA[PMCTL_DATA_ALARM2_HOUR_NO],		//SubAddress 0x3A
	& PMCTL_DATA[PMCTL_DATA_ALARM2_DAY_NO],			//SubAddress 0x3B
  	& PMCTL_DATA[PMCTL_DATA_ALARM2_MONTH_NO],		//SubAddress 0x3C
  	& PMCTL_DATA[PMCTL_DATA_ALARM2_YEAR_NO],		//SubAddress 0x3D

  //End of sub address table, don't move it!
  End_of_SubAddr_Table
};
//=====================================================================================
//Sub address default value
code BYTE SubAddr_Default_Table[] =
{
  	FIRMWARE_VERSION,				//SubAddress 0x00
  	HOST_CMD_NULL,                  //SubAddress 0x01
	HOST_WAKEUP_VIA_DC,             //SubAddress 0x02
	HOST_PWRDOWN_VIA_I2C,			//SubAddress 0x03
  	//default all input
  	0x00,                           //SubAddress 0x04		rGPIOA_OEN
	0x00,                           //SubAddress 0x05
  	0x00,                           //SubAddress 0x06
 	//default data = 0
  	0x00,                           //SubAddress 0x07		rGPIOA_DAT
  	0x00,                           //SubAddress 0x08
  	0x00,                           //SubAddress 0x09
	//input pin internal pull high set pull high
  	0xFF,                           //SubAddress 0x0A		rGPIOA_PHN
  	0xFF,                           //SubAddress 0x0B
  	0xFF,                           //SubAddress 0x0C
	//
	0xFF,                           //SubAddress 0x0D		rGPIOA_TPY
  	0xFF,                           //SubAddress 0x0E	
  	0xFF,                           //SubAddress 0x0F
	//debug data  
 	0x00,       				    //SubAddress 0x10
  	0x00,          					//SubAddress 0x11
  	0x00,          					//SubAddress 0x12
  	0x00,          					//SubAddress 0x13

	0x21,				            //SubAddress 0x14 wakwup source IR,AKEY
    0x31,                           //SubAddress 0x15 power down source IR,IR,AKEY   
	//ADC 
  	0x01,                           //SubAddress 0x16		
	0x00,                           //SubAddress 0x17
	0x00,                           //SubAddress 0x18
	0x00,                           //SubAddress 0x19
	0x00,                           //SubAddress 0x1A
	0x00,                           //SubAddress 0x1B
	0x00,                           //SubAddress 0x1C
//PWM 
	0x03,                           //SubAddress 0x1D		
	0x00,                           //SubAddress 0x1E
	0x00,                           //SubAddress 0x1F
	0x00,                           //SubAddress 0x20		
	0x00,                           //SubAddress 0x21		
	0x03,                           //SubAddress 0x22
	0xFF,                           //SubAddress 0x23
	0x00,                           //SubAddress 0x24	
	0x00,                           //SubAddress 0x25		
	//IR format
   	HW_IR_DATA_TYPE,                //SubAddress 0x26	//0x00 -> NEC, 0x01 ->RC5
	//IR custom & data code 
	#ifdef ENABLE_IR_MODE 
  	(IR_CUSTOM_CODE >> 8),          //SubAddress 0x27
  	(IR_CUSTOM_CODE & 0xFF),        //SubAddress 0x28
  	IR_DETECT_KEY,                  //SubAddress 0x29
  	(~IR_DETECT_KEY),               //SubAddress 0x2A
	#else
  	0xFF,                           //SubAddress 0x27
  	0xFF,                           //SubAddress 0x28
  	0xFF,                           //SubAddress 0x29
  	0xFF,                           //SubAddress 0x2A
	#endif
	//RTC 
  	0x00,                           //SubAddress 0x2B
	0x00,                           //SubAddress 0x2C
  	0x00,                           //SubAddress 0x2D
  	0x00,                           //SubAddress 0x2E
  	0x00,                           //SubAddress 0x2F
  	0x00,                           //SubAddress 0x30
  	0x00,                           //SubAddress 0x31
	//ALARM 1
  	0x00,                           //SubAddress 0x32
  	0x00,                           //SubAddress 0x33
  	0x00,                           //SubAddress 0x34
  	0x00,                           //SubAddress 0x35
  	0x00,                           //SubAddress 0x36
  	0x00,                           //SubAddress 0x37
	//ALARM 2
  	0x00,                           //SubAddress 0x38
  	0x00,                           //SubAddress 0x39
  	0x00,                           //SubAddress 0x3A
  	0x00,                           //SubAddress 0x3B
  	0x00,                           //SubAddress 0x3C
  	0x00,                           //SubAddress 0x3D

	
};


