#ifndef OS_H
#define OS_H
//ICE
#define WT51F516EmbededICE  	Enable 
		
#define	Enable				1
#define	Disable				0
//OS
//#define SYS_XTAL                XTAL_24M
#define SYS_XTAL                	XTAL_12M


//Xtal
#define XTAL_8M 				(8000000)
#define XTAL_11M 				(11059200)	
#define XTAL_12M 				(12*1000000)
#define XTAL_14M 				(14*1000000)
#define XTAL_16M 				(16*1000000)	
#define XTAL_24M 				(24*1000000)
#define XTAL_22M 				(22114800)

#define XTAL_1M 				(1000000)
//===================================================
//
//===================================================
			

//==========================================================

//OS timer
#define OS_TIMER0_1MS             (WORD)(0.001/(12.0/(float)SYS_XTAL))			//Timer0 run 12T
#define OS_TIMER0_BASE            10*OS_TIMER0_1MS   //10ms


#define OS_TIMER1_1MS             (WORD)(0.001/(12.0/(float)SYS_XTAL))			//Timer0 run 12T
#define OS_TIMER1_BASE            10*OS_TIMER1_1MS   //10ms


#define OS_TIMER2_1MS             (WORD)(0.001/(12.0/(float)SYS_XTAL))			//Timer0 run 12T
#define OS_TIMER2_BASE            10*OS_TIMER2_1MS   //10ms
//=====================================================================================
//Power manage Control data
#define End_of_SubAddr_Table     (BYTE code *)0
//Host command
//#define	FIRMWARE_VERSION		 0x01		// 2010/11/19 
#define	FIRMWARE_VERSION		 0x02		// 2010/06/10 
//=====================================================================================
#define HOST_CMD_NULL            0xFF
#define HOST_CMD_PWRDOWN         0x00
//=====================================================================================


#define PWR_ON                   1
#define PWR_OFF                  !PWR_ON


#define	DEFAULT_POWER_STATE  	PWR_OFF		

#define LED2_PIN		        DefineBit(rGPIOA_DAT, bit0)
#define LED2_OE            		DefineBit(rGPIOA_OEN, bit0)

#define LED3_PIN		        DefineBit(rGPIOA_DAT, bit3)
#define LED_OE              	DefineBit(rGPIOA_OEN, bit3)

#define LED4_PIN		        DefineBit(rGPIOA_DAT, bit4)
#define LED4_OE 				DefineBit(rGPIOA_OEN, bit4)

#define POWER_PIN		        DefineBit(rGPIOC_DAT, bit2)
#define POWER_PIN_OE 			DefineBit(rGPIOC_OEN, bit2)

#define LED1_PIN		        DefineBit(rGPIOC_DAT, bit5)
#define LED1_OE 				DefineBit(rGPIOC_OEN, bit5)


//Wake up function enable
#define apwr_key_wakeup_en       DefineBit(PMCTL_DATA[PMCTL_DATA_WAKEUP_EN1_NO], bit0)
#define dpwr_key_wakeup_en       DefineBit(PMCTL_DATA[PMCTL_DATA_WAKEUP_EN1_NO], bit1)
#define wdt_key_wakeup_en        DefineBit(PMCTL_DATA[PMCTL_DATA_WAKEUP_EN1_NO], bit2)
#define alarm1_wakeup_en         DefineBit(PMCTL_DATA[PMCTL_DATA_WAKEUP_EN1_NO], bit3)

#define ir_wakeup_en             DefineBit(PMCTL_DATA[PMCTL_DATA_WAKEUP_EN1_NO], bit5)
//Power down function enable
#define apwr_key_pwrdown_en      DefineBit(PMCTL_DATA[PMCTL_DATA_PWRDOWN_EN1_NO], bit0)
#define dpwr_key_pwrdown_en      DefineBit(PMCTL_DATA[PMCTL_DATA_PWRDOWN_EN1_NO], bit1)
#define alarm2_pwrdown_en        DefineBit(PMCTL_DATA[PMCTL_DATA_PWRDOWN_EN1_NO], bit3)
#define i2c_pwrdown_en           DefineBit(PMCTL_DATA[PMCTL_DATA_PWRDOWN_EN1_NO], bit4)
#define ir_pwrdown_en            DefineBit(PMCTL_DATA[PMCTL_DATA_PWRDOWN_EN1_NO], bit5)
//=====================================================================================
//=====================================================================================

enum
{
  WD_RST_TIME_1S = 0x00,
  WD_RST_TIME_2S,
  WD_RST_TIME_33MS,
  WD_RST_TIME_65MS,
  WD_RST_TIME_8S,
  //																	//default value
  WD_DET_TIME_1S = 0x00,
  WD_DET_TIME_2S,  
  WD_DET_TIME_5S,
  //			

  	PMCTL_DATA_WAKEUP_EN1_NO,			//0x00
  	PMCTL_DATA_PWRDOWN_EN1_NO,          //0x01

 	PMCTL_DATA_CTL_DAT0_NO,             //0x02
  	PMCTL_DATA_CTL_DAT1_NO,             //0x03
  	PMCTL_DATA_CTL_DAT2_NO,             //0x04
  	PMCTL_DATA_CTL_DAT3_NO,             //0x05
	

  	PMCTL_DATA_ADC_EN_NO,      			//0x11
	PMCTL_DATA_ADC_DATA0H_NO,      		//0x12
	PMCTL_DATA_ADC_DATA0L_NO,      		//0x13
	PMCTL_DATA_ADC_DATA1H_NO,      		//0x12
	PMCTL_DATA_ADC_DATA1L_NO,      		//0x13

	PMCTL_DATA_SENSOR_DATAH_NO,      	//0x14
	PMCTL_DATA_SENSOR_DATAL_NO,      	//0x15	

	PMCTL_DATA_PWM_EN_NO,               //0x16

	PMCTL_DATA_IR_FORMAT_NO,			//0x1C
	PMCTL_DATA_IR_CODE0_NO,				//0x1C
	PMCTL_DATA_IR_CODE1_NO,				//0x1D
	PMCTL_DATA_IR_CODE2_NO,				//0x1E
	PMCTL_DATA_IR_CODE3_NO,				//0x1F

	
	PMCTL_DATA_ALARM1_SEC_NO,						//0x20
	PMCTL_DATA_ALARM1_MIN_NO,						//0x21
	PMCTL_DATA_ALARM1_HOUR_NO,					//0x22
	PMCTL_DATA_ALARM1_DAY_NO,					  //0x23
	PMCTL_DATA_ALARM1_MONTH_NO,					//0x24
	PMCTL_DATA_ALARM1_YEAR_NO,					//0x25

	PMCTL_DATA_ALARM2_SEC_NO,						//0x26
	PMCTL_DATA_ALARM2_MIN_NO,						//0x27
	PMCTL_DATA_ALARM2_HOUR_NO,					//0x28
	PMCTL_DATA_ALARM2_DAY_NO,					  //0x29
	PMCTL_DATA_ALARM2_MONTH_NO,					//0x2A
	PMCTL_DATA_ALARM2_YEAR_NO,					//0x2B
			


  //size, don't move it!
  PMCTL_DATA_SIZE,
  //Host wakeup status
  HOST_WAKEUP_VIA_DC = 0x00,  //DC power on
  HOST_WAKEUP_VIA_DKEY,       //Digital key
  HOST_WAKEUP_VIA_AKEY,       //Analog key
  HOST_WAKEUP_VIA_IR,         //IR
  HOST_WAKEUP_VIA_HV,         //H/V sync detect
  HOST_WAKEUP_VIA_ALARM,      //Alarm1
  //Host Power down status
  HOST_PWRDOWN_VIA_I2C = 0x00, //Slave I2C
  HOST_PWRDOWN_VIA_DKEY,      //Digital key
  HOST_PWRDOWN_VIA_AKEY,      //Analog key
  HOST_PWRDOWN_VIA_ALARM,      //Alarm2
  HOST_PWRDOWN_VIA_IR    	  //IR key

	
};
//=====================================================================================
extern BYTE idata PMCTL_DATA[];
extern BYTE idata gbSystemVersion;
extern BYTE idata gbSystemPowerDownCommand;
extern BYTE idata gbSystemWakeupState;
extern BYTE idata gbSystemPowerDownState;
extern bdata bit IR_EN_FLAG;

extern BYTE idata gbSystemWdtState;

extern code BYTE   *SubAddr_Table[];
extern code BYTE   SubAddr_Default_Table[];
extern bit gfGetRawDataFinish;
//=====================================================================================

void DRV_IntoPwrSaveMode(void);
void DRV_InitPowerOn(void);
void SYS_LoadCalibrationData(void);
void SYS_RoscCalibration(BYTE retry_cnt);
	
void  System_Power_ON(BYTE stat);
void  System_Power_OFF(BYTE stat); 
void DRV_PutRawData( void);
void DRV_DiffcountCalculation(void);
void DelayWhile(WORD  ms);
//=====================================================================================
#endif